'MMEDIT!!! Basic Version = CMM2
'MMEDIT!!! Port = COM4:115200:10,300
'MMEDIT!!! Device = CMM2

' Z80 Simulator & CP/M 2.2 OS 
' Sep 2022 - Version 1.0
' GerryL (TBS)

'Note set OPTION CONTROLs to 120 in command line prior to running this program the first time (CMM2 will remember this option for future runs)
OPTION EXPLICIT
OPTION DEFAULT NONE
OPTION CONSOLE SERIAL
OPTION BREAK 17 ' Break is CTRL Q as CPM uses CTRL C
' CP/M User Options
CONST NUMBER_CPM_DISKS = 3 ' max of 4 A: to D:
'Display/Buttons/Text Locations
CONST D_X1 = 100
CONST D_Y1 = 100 
CONST D_WIDTH = 100
CONST D_HEIGHT = 20
CONST D_THICKNESS = 3
CONST D_COLOUR = RGB(GREEN)
CONST D_V_SPACE = 3
CONST D_H_SPACE = 4
CONST L_X_OFFSET = 4
CONST L_Y_OFFSET = D_HEIGHT/2
CONST L_COLOUR = RGB(YELLOW)
CONST REG_DATA_COLOUR = RGB(RED)
CONST BUTTON_WIDTH = 20
CONST TOPL_X = 0
CONST TOPL_Y = 1
CONST BOTR_X = 2
CONST BOTR_Y = 3
CONST LARGE_BUTTON_WIDTH = BUTTON_WIDTH *4
CONST MEDIUM_BUTTON_WIDTH = BUTTON_WIDTH *2
CONST UNDERLINE_YOFFSET = MM.INFO(FONTHEIGHT)+ 3
CONST HATLINE_YOFFSET = (MM.INFO(FONTHEIGHT)/2)+ 2
CONST FILENAME_IN_WIDTH = (BUTTON_WIDTH * 8) + D_H_SPACE
CONST MSG_BOX_WIDTH = 300
CONST MSG_BOX_HEIGHT = 150
'GUI Box #'s
CONST FLAGS = 0 
CONST BREG = 1
CONST CREG = 2
CONST DREG = 3
CONST EREG = 4
CONST HREG = 5
CONST LREG= 6
CONST AREG= 7 
CONST SPREG = 8
CONST PCREG = 10 
CONST IREG = 11
CONST ADDRESS_DISPLAY = 12
CONST MEMORY_BYTE_DISPLAY = 13
CONST USER_DISPLAY = 14 
CONST RUN_TO_DISPLAY = 15
CONST STEP_DISPLAY = 16
CONST ALT_FLAGS = 17 
CONST ALT_AREG= 18 
CONST ALT_BREG = 19
CONST ALT_CREG = 20
CONST ALT_DREG = 21
CONST ALT_EREG = 22
CONST ALT_HREG = 23
CONST ALT_LREG= 24
CONST IX_REG = 25
CONST IY_REG = 26 
'GUI Button #'s
CONST RESET_BUTTON = 40
CONST STEP_BUTTON = 41
CONST RUN_BUTTON =42
CONST EXIT_BUTTON =43
CONST ZERO_BUTTON =44
CONST ONE_BUTTON = 45
CONST TWO_BUTTON = 46
CONST THREE_BUTTON = 47
CONST FOUR_BUTTON = 48
CONST FIVE_BUTTON = 49
CONST SIX_BUTTON = 50
CONST SEVEN_BUTTON = 51
CONST EIGHT_BUTTON = 52
CONST NINE_BUTTON = 53
CONST A_BUTTON = 54
CONST B_BUTTON = 55
CONST C_BUTTON = 56
CONST D_BUTTON = 57
CONST E_BUTTON = 58
CONST F_BUTTON = 59
CONST MEM_INC_BUTTON = 60
CONST MEM_DEC_BUTTON =61
CONST OK_BUTTON = 62
CONST RUN_TO_BUTTON = 63
CONST LOAD_CPM_BUTTON = 64
CONST LOAD_FILE_BUTTON = 65
CONST LOAD_HEX_FILE_BUTTON= 66
CONST ZERO_MEM_BUTTON = 67
CONST TRACE_ON_BUTTON = 102
'Area #'s
CONST A_FLAGS = 70
CONST A_AREG= 71
CONST A_BREG = 73
CONST A_CREg = 72
CONST A_DREG = 75
CONST A_EREG = 74
CONST A_HREG = 77
CONST A_LREG= 76
CONST A_SPREG = 78
CONST A_PCREG = 80 
CONST A_IREG = 81
CONST A_ADDRESS_DISPLAY = 82
CONST A_MEMORY_BYTE_DISPLAY = 83
CONST A_RUN_TO_ADDRESS = 84
CONST A_STEP_SIZE = 85
CONST A_ALT_FLAGS = 86
CONST A_ALT_AREG= 87
CONST A_ALT_BREG = 88
CONST A_ALT_CREg = 89
CONST A_ALT_DREG = 90
CONST A_ALT_EREG = 91
CONST A_ALT_HREG = 92
CONST A_ALT_LREG= 93
CONST A_IX_REG = 94
CONST A_IY_REG = 95 
'Text Box #'s
CONST A_FILE_NAME = 100
' Frame #'s
CONST MAIN_FRAME = 101
'Led #'s
CONST TRACE_LED = 103
' next control number to allocate
CONST NEXT_CTRL = 104
'Display flags
CONST UPDATE_ALL_DISPLAY = 1
CONST USER_INPUT_MODE = 2
'Registers Byte indexes in array Registers() in CFunction 
const B_REG_INDEX = 1
const C_REG_INDEX = 0
const D_REG_INDEX = 3
const E_REG_INDEX = 2
const H_REG_INDEX = 5
const L_REG_INDEX = 4
const FLAG_REG_INDEX = 7
const A_REG_INDEX = 6
CONST SPREGLO_INDEX = 8
CONST SPREGHI_INDEX = 9
CONST PCREGLO_INDEX = 10
CONST PCREGHI_INDEX = 11
const IX_REG_LSB_INDEX = 12
const IX_REG_MSB_INDEX = 13
const IY_REG_LSB_INDEX = 14
const IY_REG_MSB_INDEX = 15
const ALT_B_REG_INDEX = 17
const ALT_C_REG_INDEX = 16
const ALT_D_REG_INDEX = 19
const ALT_E_REG_INDEX = 18
const ALT_H_REG_INDEX = 21
const ALT_L_REG_INDEX = 20
const ALT_FLAG_REG_INDEX = 23
const ALT_A_REG_INDEX = 22
CONST I_REG_INDEX = 24 
CONST IFF_INDEX = 25 
CONST LSB_MMB_PARAM_INDEX = 26
CONST MSB_MMB_PARAM_INDEX = 27
CONST ERROR_INDEX = 28
CONST STEP_DEBUG = 29 'how many instructions to do per step
CONST LSB_MMB_RUN_TO_INDEX = 30
CONST MSB_MMB_RUN_TO_INDEX = 31
CONST CTR_FLAGS_INDEX = 32 
CONST NMI_PIN_INDEX = 41
CONST INT_PIN_INDEX = 42
CONST INT_MODE2_OFFSET_INDEX = 43
CONST LSB_INT_TIME = 44 ' LSB the time between each interrupt checks, 0 is check every instruction, FFFF no checks
CONST MSB_INT_TIME = 45 ' MSB of above
CONST INT_MODE2_CODE_1_INDEX = 46
CONST INT_MODE2_CODE_2_INDEX = 47
CONST INT_MODE2_CODE_3_INDEX = 48
CONST LSB_DMA_ADDRESS = 49
CONST MSB_DMA_ADDRESS = 50
CONST KB_BUFFER_HEAD_INDEX = 63 ' index into buffer
CONST KB_BUFFER_TAIL_INDEX = 64 ' number unread chars
CONST CPM_FILE_EXPORT_FLAG = 71 ' if 0 then overwrite file if exists
CONST INST_LOG_ON = 72 ' if 0 not logging instruction to terminal
CONST DEBUG_FLAG = &HFFFF ' if set to &H44 then will cause CTRL c in CP/M to come back to the MMBASIC program instead of CP/M normal warm boot of reloading CCP.hex
' CFUNCTION FLAG BYTE, CtrlFlags used to control aspects of CFunction
const FLAG_STEP = 1
CONST FLAG_END_PROGRAM = 2
CONST FLAG_RUN = 4
CONST FLAG_INIT = 8 ' Init is 0 on startup, but set to 1 after CFunction initialised
CONST FLAG_RUN_TO = 16
'Disk Size, Note this is fixed as the BIOS sets this in disk parameter block
CONST DISK_SIZE = 256256 / 8 ' 256K which is 32032 integers, 
'A Reg set to for MMCB Select Case
CONST CPM_WARM_BOOT  = &H21
CONST CPM_HOME = &H28 
CONST CPM_SEL_DISK = &H29
CONST CPM_MOVE_TO_TRACK = &H2A 
CONST CPM_SETSEC = &H2B
CONST CPM_READ_DISK = &H2C 
CONST CPM_WRITE_DISK = &H2D
CONST CPM_PUNCH_OUT = &H26
CONST CPM_OPEN_EXPORT = &H80 ' opens MMBasic file CPM_EXPORT 
CONST CPM_TRANSFER_EXPORT = &H81 ' transfers 128 byes
CONST CPM_CLOSE_EXPORT = &H82 ' closes CPM_EXPORT 
CONST MMB_PAGE_DISPLAY = &H95
CONST MMB_PAGE_WRITE = &H96
const MMB_CLR = &H97
CONST MMB_TEXT_OUT = &H98
CONST MMB_GET_TIME = &H99
CONST MMB_TRACE_REG_STATUS = &H9C 
const MMB_SAVE_IMAGE = &H9D
' Variables
DIM INTEGER DisplayLoc(27,3) 'location of each box 4 corners, X,Y,X+width,Y+Height
DIM INTEGER ButtonMatrix_X(29) 'X location
DIM INTEGER ButtonMatrix_Y(29) 'Y location
DIM INTEGER MiscLoc_X(2) 'X filename locatin
DIM INTEGER MiscLoc_Y(2) ' Y File name location
DIM INTEGER gnRedraw = 0 'Flag to redraw display when file text box closed on TouchUp
DIM INTEGER gnCurrentTrack
DIM INTEGER gnCurrentSector
DIM INTEGER gnI ' loop counter
DIM INTEGER gnK 'loop counter
DIM INTEGER gnCurrentInputDisplay = 0 'what Register or display has been selected by user for input
DIM INTEGER Registers(11) ' INTEGERS = Max of 88 bytes,  
DIM INTEGER Memory64k(8192) ' 64k data
dim integer FunctArray(127) ' used for storing function pointers in CFunction, pointer = 4 bytes so each integer holds 2 pointers
DIM INTEGER gnMemoryAddress=0' as requested by user to look at a memory location
DIM INTEGER gnStepDebug = 1 ' used to keep track of how many instructins to do before returning from CFunction
DIM INTEGER gnUserInputData =0
DIM INTEGER gnRet 'common return
DIM INTEGER gnLastButtonPressed =1000 'set some value not obtainable
DIM INTEGER gnFlagUpdateDisplay=1 ' ensure we set displays on startup
dim string gsUserInput ' what the user has entered for a display
DIM STRING gsFileName 'name of file to load into memory
DIM INTEGER gnBytePos ' byte location from start of the CP/M disk
DIM INTEGER gnDAMAddress ' where reads and writes are to be stord in Memory64k()
DIM INTEGER gnExpType ' file type being exported, txt or binary
DIM INTEGER gnTraceToggle ' 0 is no log
'Instruction code strings
DIM STRING gsMainIn(12) LENGTH 200' 12 strings, an array of strings that are used to decode the Z80 opcode to ASM mnemonics, max 10 chars per mnemonic
DIM STRING gsBITSIn(3) LENGTH 200 ' 10 X 10 X 2=200
DIM STRING gsEXT_In(5) LENGTH 200 ' 10 X 10 X 2=200
DIM STRING gsIX__In(5) LENGTH 200 ' 12 X 8 X 2=192
DIM STRING gsIY__In(5) LENGTH 200 ' 12 X 8 X 2=192
' Fill array 
'                            "12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890"
                '             0         1         2         3         4         5         6         7         8         9          
               gsMainIn(0) = "NOP       LD BC,nn  LD (BC),A INC BC    INC B     DEC B     LD B, n   RLCA      EX AF 'AF ADD HL,BC " '100, 10, 09h
  gsMainIn(0) =gsMainIn(0) + "LD A,(BC) DEC BC    INC C     DEC C     LD C, n   RRCA      DJNZ n    LD DE, nn LD (DE),A INC DE    " '200, 20, 13h
               gsMainIn(1) = "INC D     DEC D     LD D, n   RLA       JR n      ADD HL,DE LD A,(DE) DEC DE    INC E     DEC E     " '100, 30, 1dh 
  gsMainIn(1) =gsMainIn(1) + "LD E,n    RRA       JR NZ, n  LD HL,nn  LD (nn),HLINC HL    INC H     DEC H     LD H,n    DAA       " '200, 40, 27h
               gsMainIn(2) = "JR Z,n    AD HL,HL  LD HL,(nn)DEC HL    INC L     DEC L     LD L, n   CPL       JR NC, n  LD SP,nn  " '100, 50, 31h
  gsMainIn(2) =gsMainIn(2) + "LD (nn),A INC SP    INC (HL)  DEC (HL)  LD (HL),n SCF       JR C,n    ADD HL,SP LD A,(nn) DEC SP    " '200, 60, 3bh
               gsMainIn(3) = "INC A     DEC A     LD A,n    CCF       LD B,B    LD B,C    LD B,D    LD B,E    LD B,H    LD B,L    " '100, 70, 45h
  gsMainIn(3) =gsMainIn(3) + "LD B,(HL) LD B,A    LD C,B    LD C,C    LD C,D    LD C,E    LD C,H    LD C,L    LD C,(HL) LD C,A    " '200, 80, 4fh
               gsMainIn(4) = "LD D,B    LD D,C    LD D,D    LD D,E    LD D,H    LD D,L    LD D,(HL) LD D,A    LD E,B    LD E,C    " '100, 90, 59h
  gsMainIn(4) =gsMainIn(4) + "LD E,D    LD E,E    LD E,H    LD E,L    LD E,(HL) LD E,A    LD H,B    LD H,C    LD H,D    LD H,E    " '200, 100, 63h 
               gsMainIn(5) = "LD H,H    LD H,L    LD H,(HL) LD H,A    LD L,B    LD L,C    LD L,D    LD L,E    LD L,H    LD L,L    " '100, 110, 6dh
  gsMainIn(5) =gsMainIn(5) + "LD L,(HL) LD L,A    LD (HL),B LD (HL),C LD (HL),D LD (HL),E LD (HL),H LD (HL),L HALT      LD(HL),A  " '200, 120, 77h   
               gsMainIn(6) = "LD A,B    LD A,C    LD A,D    LD A,E    LD A,H    LD A,L    LD A,(HL) LD A,A    ADD A,B   ADD A,C   " '100, 130, 81h
  gsMainIn(6) =gsMainIn(6) + "ADD A,D   ADD A,E   ADD A,H   ADD A,L   ADD A,(HL)ADD A,A   ADC A,B   ADC A,C   ADC A,D   ADC A,E   " '200, 140, 8bh  
               gsMainIn(7) = "ADC A,H   ADC A,L   ADC A,(HL)ADC,A,A   SUB B     SUB C     SUB D     SUB E     SUB H     SUB L     " '100, 150, 95h             
  gsMainIn(7) =gsMainIn(7) + "SUB (HL)  SUB A     SBC A,B   SBC A,C   SBC A,D   SBC A,E   SBC A,H   SBC A,L   SBC A,(HL)SBC A,A   " '200, 160, 9fh
               gsMainIn(8) = "AND B     AND C     AND D     AND E     AND H     AND L     AND (HL)  AND A     XOR B     XOR C     " '100, 170, a9h
  gsMainIn(8) =gsMainIn(8) + "XOR D     XOR E     XOR H     XOR L     XOR (HL)  XOR A     OR B      OR C      OR D      OR E      " '200, 180, b3h 
               gsMainIn(9) = "OR H      OR L      OR (HL)   OR A      CP B      CP C      CP D      CP E      CP H      CP L      " '100, 190, bdh
  gsMainIn(9) =gsMainIn(9) + "CP (HL)   CP A      RET NZ    POP BC    JP NZ,nn  JP nn     CALL NZ,nnPUSH BC   ADD A,n   RST 00h   " '200, 200, c7
              gsMainIn(10) = "RET Z     RET       JP Z,nn   BITS      CALL Z,nn CALL nn   ADC A,n   RST 08h   RET NC    POP DE    " '100, 210, d1h
 gsMainIn(10)=gsMainIn(10) + "JP NC,nn  OUT (n),A CALL NC,nnPUSH DE   SUB n     RST 10h   RET C     EXX       JP C,nn   IN A,(n)  " '200, 220, dbh
              gsMainIn(11) = "CALL C,nn IX        SBC A,n   RST 18h   RET PO    POP HL    JP PO,nn  EX (SP),HLCALL PO,nnPUSH HL   " '100, 230, e5h
 gsMainIn(11)=gsMainIn(11) + "AND n     RST 20h   RET PE    JP (HL)   JP PE,nn  EX DE,HL  CALL PE,nnEXTF      XOR n     RST 28h   " '200, 240, efh
              gsMainIn(12) = "RET P     POP AF    JP P,nn   DI        CALL P,nn PUSH AF   OR n      RST 30h   RET M     LD SP,HL  " '100, 250, f9h
 gsMainIn(12)=gsMainIn(12) + "JP M,nn   EI        CALL M,nn IY        CP n      RST 38h                                           " '200, 255, ffh  
' Element 13 = Start of CB BITS codes
               gsBITSIn(0) = "RLC B     RLC C     RLC D     RLC E     RLC H     RLC L     RLC (HL)  RLC A     RRC B     RRC C     "  '100, 10, 09h
   gsBITSIn(0)=gsBITSIn(0) + "RRC D     RRC E     RRC H     RRC L     RRC (HL)  RRC A     RL B      RL C      RL D      RL E      "  '200, 20, 13h
               gsBITSIn(1) = "RL H      RL L      RL (HL)   RL A      RR B      RR C      RR D      RR E      RR H      RR L      "  '100, 30, 1dh
   gsBITSIn(1)=gsBITSIn(1) + "RR (HL)   RR A      SLA B     SLA C     SLA D     SLA E     SLA H     SLA L     SLA (HL)  SLA A     "  '200, 40, 27h              
               gsBITSIn(2) = "SRA B     SRA C     SRA D     SRA E     SRA H     SRA L     SRA (HL)  SRA A     SLL B               "  '100, 50, 31h
   gsBITSIn(2)=gsBITSIn(2) + "                                                            SRL B     SRL C     SRL D     SRL E     "  '200, 60, 3bh              
               gsBITSIn(3) = "SRL H     SRL L     SRL (HL)  SRL A                                                                 "  '100, 70, 3fh
 ' Extended Instruction Set (&HED), starts at &H40              
               gsEXT_In(0) = "IN B,(C)  OUT (C),B SBC HL,BC LD (nn),BCNEG       RETN      IM 0      LD I,A    IN C,(C)  OUT (C),C "  '100, 10, 49h
   gsEXT_In(0)=gsEXT_In(0) + "ADC HL,BC LD BC,(nn)          RET I               LD R,A    IN D,(C)  OUT (C),D SBC HL,DE LD (nn),DE"  '200, 20, 53h
               gsEXT_In(1) = "          RETN      IM 1      LD I,A    IN E,(C)  OUT (C),E ADC HL,DE LD DE,(nn)          RETN      "  '100, 30, 5dh     
   gsEXT_In(1)=gsEXT_In(1) + "IM 2      LD A,R    IN H,(C)  OUT (C),H SBC HL,HL                     RETN      IM 0      RRD       "  '200, 40, 67h 
               gsEXT_In(2) = "IN L,(C)  OUT (C),L ADC HL,HL                     RETN                RLD                           "  '100, 50, 71h
   gsEXT_In(2)=gsEXT_In(2) + "SBC HL,SP LD (nn),SP          RETN      IM 1                IN A,(C)  OUT (C),A ADC HL,SP LD SP,(nn)"  '200, 60, 7bh  
               gsEXT_In(3) = "          RETN      IM 2                                                                            "  '100, 63, 7fh
' next set of codes start at &HA0 & element 4
               gsEXT_In(4) = "LDI       CPI       INI       OUT I     BLANK     BLANK     BLANK     BLANK     LDD       CPD       "  '100, 73, a9h
   gsEXT_In(4)=gsEXT_In(4) + "IND       OUTD      BLANK     BLANK     BLANK     BLANK     LDIR      CPIR      INIR      OUTIR     "  '200, 83, b3h 
               gsEXT_In(5) = "BLANK     BLANK     BLANK     BLANK     LDDR      CPDR      INDR      OTDR                          "  '100, 73, bdh 
'IX
'                            "12345678901212345678901212345678901212345678901212345678901212345678901212345678901212345678901212345678912"
                '             0           1           2           3           4           5           6           7           8                          
               gsIX__In(0) = "MMB                                                                                             " ' 07h
   gsIX__In(0)=gsIX__In(0) + "            ADD IX,BC                                                                           " ' 0fh            
               gsIX__In(1) = "                                                                                                " ' 17h
   gsIX__In(1)=gsIX__In(1) + "            ADD IX,DE                                                                           " ' 1fh
               gsIX__In(2) = "            LD IX,nn    LD (nn),IX  INC IX                                                      " ' 27h
   gsIX__In(2)=gsIX__In(2) + "            ADD IX,IX   LD IX,(nn)  DEC IX                                                      " ' 2fh 
               gsIX__In(3) = "                                                INC (IX+d)  DEC (IX+d)   LD(IX+d)               " ' 37h
   gsIX__In(3)=gsIX__In(3) + "            ADD IX,SP                                                                           " ' 3fh
               gsIX__In(4) = "LD (IX+d),B LD (IX+d),C LD (IX+d),D LD (IX+d),E LD (IX+d),H LD (IX+d),L             LD (IX+d),A " ' 77h
   gsIX__In(4)=gsIX__In(4) + "                                                                         LD A,(IX+d)            " ' 7f             
               gsIX__In(5) = "            POP IX                  EX (SP),IX              PUSH IX                             " ' e7h            
   gsIX__In(5)=gsIX__In(5) + "            JP (IX)                                                                             " ' efh
'IY   
'                            "12345678901212345678901212345678901212345678901212345678901212345678901212345678901212345678901212345678912"
                '             0           1           2           3           4           5           6           7           8                          
               gsIY__In(0) = "MMB                                                                                             " ' 07h
   gsIY__In(0)=gsIY__In(0) + "                        ADD IY,BC                                                               " ' 0fh            
               gsIY__In(1) = "                                                                                                " ' 17h
   gsIY__In(1)=gsIY__In(1) + "                        ADD IY,BC                                                               " ' 1fh
               gsIY__In(2) = "            LD IY,nn    LD (nn),IY  INC IY                                                      " ' 27h
   gsIY__In(2)=gsIY__In(2) + "            ADD IY,IY   LD IY,(nn)  DEC IY                                                      " ' 2fh 
               gsIY__In(3) = "                                                INC (IY+d)  DEC (IY+d)   LD(IY+d)               " ' 37h
   gsIY__In(3)=gsIY__In(3) + "            ADD IY,SP                                                                           " ' 3fh
               gsIY__In(4) = "LD (IY+d),B LD (IY+d),C LD (IY+d),D LD (IY+d),E LD (IY+d),H LD (IY+d),L             LD (IY+d),A " ' 77h
   gsIY__In(4)=gsIY__In(4) + "                                                                         LD A,(IX+d)            " ' 7f             
               gsIY__In(5) = "            POP IY                  EX (SP),IY              PUSH IY                             " ' e7h            
   gsIY__In(5)=gsIY__In(5) + "            JP (IY)                                                                             " ' efh
      
CLS
Initialise
gui cursor on 0, mm.hres\2,mm.vres\2
GUI Interrupt TouchDown 
GUI CURSOR COLOUR RGB(CYAN)
gnFlagUpdateDisplay = UPDATE_ALL_DISPLAY
UpdateRegistersDisplay
Page write 1
CLS
Page write 0
DO ' main loop forever
  if gnRedraw THEN
    GUI REDRAW ALL
    DrawRegisters    
    gnFlagUpdateDisplay = UPDATE_ALL_DISPLAY
    UpdateRegistersDisplay
    gnRedraw = 0
  end if
  if (PEEK(VAR Registers(), CTR_FLAGS_INDEX) AND FLAG_END_PROGRAM) then
    POKE VAR Registers(), PCREGLO_INDEX, 0 ' Reset PCREG
    POKE VAR Registers(), PCREGHI_INDEX, 0
    POKE VAR Registers(), CTR_FLAGS_INDEX, FLAG_INIT 'clear flags except init
  end if
  if gnLastButtonPressed < NEXT_CTRL then
    Select Case gnLastButtonPressed
      case LOAD_FILE_BUTTON
        if gsFileName = "" THEN
          WarnUserMsg "FILE NAME NOT DEFINED", "ENTER A FILE NAME IN FILE BOX"
          RedrawScreen
        ELSE
          LoadCPMFile  gsFileName, "A" ' force A drive
        ENDIF
      CASE LOAD_HEX_FILE_BUTTON
        if gsFileName = "" THEN
          WarnUserMsg "FILE NAME NOT DEFINED", "ENTER A FILE NAME IN FILE BOX"
          RedrawScreen
        ELSE
          LoadHexFile  gsFileName
          POKE VAR Registers(), PCREGLO_INDEX, 0 ' PC set to Cold Start Boot
          POKE VAR Registers(), PCREGHI_INDEX, 0 
          gnFlagUpdateDisplay = UPDATE_ALL_DISPLAY
          UpdateRegistersDisplay
        ENDIF
      case ZERO_MEM_BUTTON
        Registers(0) = 0
        Registers(1) = 0
        Registers(2) = 0
        MATH SET 0, Memory64k()
        gnFlagUpdateDisplay = UPDATE_ALL_DISPLAY
        UpdateRegistersDisplay
        SetCallBackName
      case LOAD_CPM_BUTTON
        CtrlVal(MAIN_FRAME) = " CP/M 2.2 Operating System "
        LoadCPM
      case A_FILE_NAME
         gsFileName = InputFileName(MiscLoc_X(0), MiscLoc_Y(0))
      case RESET_BUTTON
        POKE VAR Registers(), PCREGLO_INDEX, 0 ' PC set to zero address
        POKE VAR Registers(), PCREGHI_INDEX, 0
        POKE VAR Registers(), KB_BUFFER_HEAD_INDEX, 0
        POKE VAR Registers(), KB_BUFFER_TAIL_INDEX, 0
        Registers(0) = 0
        Registers(1) = 0
        Registers(2) = 0
        gnFlagUpdateDisplay = UPDATE_ALL_DISPLAY 
      CASE STEP_BUTTON
        POKE VAR Registers(), CTR_FLAGS_INDEX, (FLAG_INIT OR FLAG_STEP)
        POKE VAR Registers(), STEP_DEBUG, gnStepDebug  
        CSim Memory64k(), Registers(),FunctArray()
        CheckError
        gnFlagUpdateDisplay = UPDATE_ALL_DISPLAY 
      CASE RUN_TO_BUTTON
        POKE VAR Registers(), CTR_FLAGS_INDEX, (FLAG_INIT OR FLAG_RUN_TO)
        CSim Memory64k(), Registers(),FunctArray()
        gnFlagUpdateDisplay = UPDATE_ALL_DISPLAY  
        CheckError
      case TRACE_ON_BUTTON
        if gnTraceToggle =  1 then ' its ON so turn off
          gnTraceToggle = 0
          CtrlVal(TRACE_LED) = 0
          POKE VAR Registers(), INST_LOG_ON, 0 
        else ' turn ON
            POKE VAR Registers(), INST_LOG_ON, 1 
            gnTraceToggle = 1
            CtrlVal(TRACE_LED) = 1
        ENDIF
      case RUN_BUTTON
        POKE VAR Registers(), CTR_FLAGS_INDEX, (FLAG_INIT OR FLAG_RUN)
        CtrlVal(TRACE_LED) = 0
        gnTraceToggle = 0 ' cant trace in run
        POKE VAR Registers(), INST_LOG_ON, 0 
        CSim Memory64k(), Registers(),FunctArray()
        CheckError
      CASE  EXIT_BUTTON
        END ' exit program
      case A_FLAGS TO A_STEP_SIZE
        SetDisplayInput
      case A_IX_REG
        SetDisplayInput
      case A_IY_REG
        SetDisplayInput  
      CASE MEM_INC_BUTTON
        if gnMemoryAddress < &HFFFF then INC gnMemoryAddress
        gnFlagUpdateDisplay = UPDATE_ALL_DISPLAY
      CASE MEM_DEC_BUTTON
        if gnMemoryAddress > 0 then INC gnMemoryAddress, -1
        gnFlagUpdateDisplay = UPDATE_ALL_DISPLAY
       CASE ZERO_BUTTON
        gsUserInput = gsUserInput+ "0"
        gnFlagUpdateDisplay = USER_INPUT_MODE
      cASE ONE_BUTTON 
        gsUserInput = gsUserInput+ "1"
        gnFlagUpdateDisplay = USER_INPUT_MODE
      case TWO_BUTTON
        gsUserInput = gsUserInput+ "2"
        gnMemoryAddress = VAL(gsUserInput)
        gnFlagUpdateDisplay = USER_INPUT_MODE
      cASE THREE_BUTTON
        gsUserInput = gsUserInput+ "3"
        gnFlagUpdateDisplay = USER_INPUT_MODE
      cASE FOUR_BUTTON 
        gsUserInput = gsUserInput+ "4"
        gnFlagUpdateDisplay = USER_INPUT_MODE
      cASE FIVE_BUTTON
        gsUserInput = gsUserInput+ "5"
        gnFlagUpdateDisplay = USER_INPUT_MODE
      cASE SIX_BUTTON
        gsUserInput = gsUserInput+ "6"
        gnFlagUpdateDisplay = USER_INPUT_MODE
      cASE SEVEN_BUTTON
        gsUserInput = gsUserInput+ "7"
        gnFlagUpdateDisplay = USER_INPUT_MODE
      cASE EIGHT_BUTTON
        gsUserInput = gsUserInput+ "8"
        gnFlagUpdateDisplay = USER_INPUT_MODE
      cASE NINE_BUTTON
        gsUserInput = gsUserInput+ "9"
        gnFlagUpdateDisplay = USER_INPUT_MODE
      cASE A_BUTTON
        gsUserInput = gsUserInput+ "A"
        gnFlagUpdateDisplay = USER_INPUT_MODE
      cASE B_BUTTON
        gsUserInput = gsUserInput+ "B"
        gnFlagUpdateDisplay = USER_INPUT_MODE
      cASE C_BUTTON
        gsUserInput = gsUserInput+ "C"
        gnFlagUpdateDisplay = USER_INPUT_MODE
      cASE D_BUTTON
        gsUserInput = gsUserInput+ "D"
        gnFlagUpdateDisplay = USER_INPUT_MODE
      cASE E_BUTTON
        gsUserInput = gsUserInput+ "E"
        gnFlagUpdateDisplay = USER_INPUT_MODE
      cASE F_BUTTON
        gsUserInput = gsUserInput+ "F"
        gnFlagUpdateDisplay = USER_INPUT_MODE
      CASE OK_BUTTON
        if Is16BitDisplay() = 1 then
         gnUserInputData = VAL("&H"+left$(gsUserInput,4))
        else
          gnUserInputData = VAL("&H"+left$(gsUserInput,2))
        end if
        select Case gnCurrentInputDisplay
          case FLAGS
            POKE VAR Registers(), FLAG_REG_INDEX, gnUserInputData
          case IREG
            POKE VAR Registers(), I_REG_INDEX, gnUserInputData
          case AREG
            POKE VAR Registers(), A_REG_INDEX, gnUserInputData
          case BREG
            POKE VAR Registers(), B_REG_INDEX, gnUserInputData
          case CREg
            POKE VAR Registers(), C_REG_INDEX, gnUserInputData
          case DREG
            POKE VAR Registers(), D_REG_INDEX, gnUserInputData
          case EREG
            POKE VAR Registers(), E_REG_INDEX, gnUserInputData
          case HREG
            POKE VAR Registers(), H_REG_INDEX, gnUserInputData
          case LREG
            POKE VAR Registers(), L_REG_INDEX, gnUserInputData
          case ADDRESS_DISPLAY
            gnMemoryAddress =  gnUserInputData    
          CASE MEMORY_BYTE_DISPLAY
            POKE VAR Memory64k(), gnMemoryAddress, gnUserInputData
          CASE RUN_TO_DISPLAY
            POKE VAR Registers(), LSB_MMB_RUN_TO_INDEX, gnUserInputData AND &HFF
            POKE VAR Registers(), MSB_MMB_RUN_TO_INDEX, (gnUserInputData AND &HFF00) >> 8
          CASE STEP_DISPLAY
            gnStepDebug = gnUserInputData  AND &HFF' max 255 steps
            if gnStepDebug < 1 then 
              gnStepDebug = 1
            END IF
          case IX_REG
            POKE VAR Registers(), IX_REG_LSB_INDEX, gnUserInputData AND &HFF  
            POKE VAR Registers(), IX_REG_MSB_INDEX, (gnUserInputData AND &HFF00) >> 8
          case IY_REG
            POKE VAR Registers(), IY_REG_LSB_INDEX, gnUserInputData AND &HFF  
            POKE VAR Registers(), IY_REG_MSB_INDEX, (gnUserInputData AND &HFF00) >> 8  
        end select
      gnFlagUpdateDisplay = UPDATE_ALL_DISPLAY ' part of OK
      gsUserInput = ""
    END SELECT
    if gnFlagUpdateDisplay <> 0  UpdateRegistersDisplay
    gnLastButtonPressed = 1000 ' ensure only do once
  end if 'gnLastButtonPressed < xx
  if KEYDOWN(0) > 0 then ' at least one key pressed, manage key commands
    gnRet = KEYDOWN(1)
    IF gnRet > 96 then ' set to upper case
      gnRet = gnRet - 32
    end if
    select case KEYDOWN(7)
    case 2 'ITS LCTRL
      select case gnRet
        case 9 'CTRL I INC
          gnLastButtonPressed = MEM_INC_BUTTON 
        case 4 'CTRL D DEC
          gnLastButtonPressed = MEM_DEC_BUTTON  
        case 15 'CTRL O OK
          gnLastButtonPressed = OK_BUTTON      
        case 18 'CTRL R RUN
          gnLastButtonPressed = RUN_BUTTON 
        case 16 'CTRL P 
          SAVE IMAGE "PanelSim.bmp"
        case 20 'CTRL T RST
          gnLastButtonPressed = RESET_BUTTON   
        case 19 'CTRL S STEP
          gnLastButtonPressed = STEP_BUTTON  
        case 24 'CTRL X EXIT
          gnLastButtonPressed = EXIT_BUTTON  
        case 21 'CTRL U RUN TO
          gnLastButtonPressed = RUN_TO_BUTTON  
        case 13 'CTRL M Load CP/M
          gnLastButtonPressed = LOAD_CPM_BUTTON 
        case 6 'CTRL F Load CP/M file to &H100
          gnLastButtonPressed = LOAD_FILE_BUTTON
        case 8 'CTRL H Load Hex file
          gnLastButtonPressed = LOAD_HEX_FILE_BUTTON  
        case 26 'CTRL Z Zero Memory
          gnLastButtonPressed = ZERO_MEM_BUTTON  
        case 1 'CTRL A TRACE
          gnLastButtonPressed = TRACE_ON_BUTTON   
      end select
    case 1 'ITS LEFT ALT
      select case gnRet
        case 70 'ALT F
          gnLastButtonPressed = A_FLAGS  
        case 65 'ALT A
          gnLastButtonPressed = A_AREG   
        case 66 'ALT B
          gnLastButtonPressed = A_BREG  
        case 67 'ALT C
          gnLastButtonPressed = A_CREg    
        case 68 'ALT D
          gnLastButtonPressed = A_DREG   
        case 69 'ALT E
          gnLastButtonPressed = A_EREG  
        case 72 'ALT H
          gnLastButtonPressed = A_HREG  
        case 76 'ALT L
          gnLastButtonPressed = A_LREG  
        case 83 'ALT S ADDRESS
          gnLastButtonPressed = A_ADDRESS_DISPLAY  
        case 77 'ALT M MEMORY
          gnLastButtonPressed = A_MEMORY_BYTE_DISPLAY   
        case 79 'ALT M MEMORY
          gnLastButtonPressed = A_RUN_TO_ADDRESS   
        case 80 'ALT S STEP
          gnLastButtonPressed = A_STEP_SIZE
        case 88 'ALT X IX Reg
          gnLastButtonPressed = A_IX_REG  
        case 89 'ALT Y IY Reg
          gnLastButtonPressed = A_IY_REG   
        case 78 'ALT N File Name Input
          gnLastButtonPressed = A_FILE_NAME                                                                         
      end select
    case 16 'ITS RIGHT ALT, HEX Key pad
      select case gnRet
        case 48 'ZERO
          gnLastButtonPressed = ZERO_BUTTON  
        case 49 'ONE
          gnLastButtonPressed = ONE_BUTTON
        case 50 'TWO
          gnLastButtonPressed = TWO_BUTTON
        case 51 'THREE
          gnLastButtonPressed = THREE_BUTTON 
        case 52 'FOUR
          gnLastButtonPressed = FOUR_BUTTON
        case 53 'FIVE
          gnLastButtonPressed = FIVE_BUTTON 
        case 54 'SIX
          gnLastButtonPressed = SIX_BUTTON 
        case 55 'SEVEN
          gnLastButtonPressed = SEVEN_BUTTON 
        case 56 'EIGHT
          gnLastButtonPressed = EIGHT_BUTTON
        case 57 'NINE
          gnLastButtonPressed = NINE_BUTTON 
        case 65 'A
          gnLastButtonPressed = A_BUTTON
        case 66 'B
          gnLastButtonPressed = B_BUTTON
        case 67 'C
          gnLastButtonPressed = C_BUTTON
        case 68 'D
          gnLastButtonPressed = D_BUTTON 
        case 69 'E
          gnLastButtonPressed = E_BUTTON 
        case 70 'F
          gnLastButtonPressed = F_BUTTON                                                      
        END SELECT ' ON KEY PAD
    END SELECT ' on (7)
    ENDIF 'KeyDown(7)
    DO WHILE KEYDOWN(0) > 0 ' ENSURE ONLY ONE ACTION PER PRESS
    LOOP
  end if ' KEY PRESS
Loop ' forever

SUB Initialise
  'dont zero any registers or memory so it remains intact if need to sort out bugs
 ' see if we have Disk A, B, etc to NUMBER_CPM_DISKS
  local integer lnFuncError =0, lnCtr=0, lnDisks = 1, lnTemp
  Do While lnDisks <= NUMBER_CPM_DISKS
    CreateDisk lnDisks
    Inc lnDisks
  loop
  POKE VAR Registers(), KB_BUFFER_HEAD_INDEX, 0 ' clear console buffer
  POKE VAR Registers(), KB_BUFFER_TAIL_INDEX, 0
  POKE VAR Registers(), CTR_FLAGS_INDEX, 0 ' reset all flags
  POKE VAR Registers(), CPM_FILE_EXPORT_FLAG, 0 ' reset CP/M export flag
  POKE VAR Registers(), INST_LOG_ON, 0 
  gnTraceToggle = 0
  MATH SET 0, FunctArray() ' reset
  CSim Memory64k(), Registers(),FunctArray() ' set C function pointers into array
  SetCallBackName
  POKE VAR Registers(), PCREGLO_INDEX, 0 ' start at address 0 
  POKE VAR Registers(), PCREGHI_INDEX, 0
  ' check all functions set up
  for gnI = 0 to 127
    if (FunctArray(gnI) AND &HFFFFFFFF) = 0 THEN
      print "MAJOR ERROR!!!! Did not set up all function pointers during initialisation" + " Even Index = ", lnCtr 
      INC lnFuncError
    end if
    INC lnCtr
    IF (FunctArray(gnI) AND &HFFFFFFFF00000000) = 0 then
      print "MAJOR ERROR!!!! Did not set up all function pointers during initialisation" + " Odd Index = ", lnCtr ' second pointer
      INC lnFuncError
    end if
    INC lnCtr
  next gnI
  if lnFuncError <> 0 then
    pause 1000
    END ' exit we have major problem
  END IF
  SetDisplayLocArray
  DrawDisplay
  gnFlagUpdateDisplay = 1
  UpdateRegistersDisplay
  CtrlVal(TRACE_LED) = 0
  'Note to set Interrupt time the assembly program can set this counter to the required microseconds between checks, FFFF = checks OFF
  POKE VAR Registers(), LSB_INT_TIME, &HFF ' turn off int check by setting to FFFF  
  POKE VAR Registers(), MSB_INT_TIME, &HFF  
END SUB 
  
SUB CheckError
  if PEEK(VAR Registers(), ERROR_INDEX) <> 0 then
    Select Case PEEK(VAR Registers(), ERROR_INDEX)
    'case ERROR_Z80_CODE
    '  gnRet = MsgBox("ERROR! Z80 INSTRUCTION DETECTED!","OK")
   ' end select  
    GUI REDRAW ALL
    DrawRegisters
    gnFlagUpdateDisplay = UPDATE_ALL_DISPLAY
    UpdateRegistersDisplay
    POKE VAR Registers(), ERROR_INDEX, 0 ' reset error
  ENDIF
END SUB

FUNCTION Is16BitDisplay() AS INTEGER
  ' Determines if the current display is 16 bit
  Select Case gnCurrentInputDisplay
    case SPREG
      Is16BitDisplay = 1
    case PCREG
      Is16BitDisplay = 1
    case ADDRESS_DISPLAY
      Is16BitDisplay = 1
    case RUN_TO_DISPLAY
      Is16BitDisplay = 1 
    case STEP_DISPLAY
      Is16BitDisplay = 1 
    case IX_REG
      Is16BitDisplay = 1  
    case IY_REG
      Is16BitDisplay = 1 
    CASE ELSE
      Is16BitDisplay = 0             
  END SELECT    
end Function

SUB LoadCPM
  LoadHexFile "CCP.HEX"
  LoadHexFile "BDOS.HEX"
  LoadHexFile "BIOS.HEX"
  SetCallBackName
  POKE VAR Registers(), PCREGLO_INDEX, 0 ' PC set to Cold Start Boot
  POKE VAR Registers(), PCREGHI_INDEX, &HFA
  POKE VAR Registers(), CPM_FILE_EXPORT_FLAG, 0
  gnFlagUpdateDisplay = UPDATE_ALL_DISPLAY
  UpdateRegistersDisplay
END SUB

SUB SetCallBackName
  POKE VAR Registers(), 33, 77 'M
  POKE VAR Registers(), 34, 77 'M
  POKE VAR Registers(), 35, 67 'C
  POKE VAR Registers(), 36, 66 'B
  POKE VAR Registers(), 37, 0 '0
  POKE VAR Registers(), 38, 0 '0
end sub

SUB LoadCPMFile( FileName as STRING, DiskNumber as STRING)
' Places the File in memory at &H100,assumes its a file stored on the CMM2 SD disk
' File Name is the File to load up
' The user then uses SAVE to save the file onto the disk so it appears as a CP/M 2.2 file
' Add CTRL Z to end of file
  LOCAL AS INTEGER nLineAdd, nIn
  ON ERROR SKIP 1
  OPEN FileName FOR INPUT AS #2
  if MM.ERRNO <> 0 then
    'gnRet = MsgBox("ERROR FILE COULD NOT BE OPENED!~CHECK FILE NAME","OK")
    WarnUserMsg "ERROR FILE COULD NOT BE OPENED", "CHECK FILE NAME"
    RedrawScreen
    EXIT SUB ' error
  endif
  nLineAdd = &H100
  do while NOT EOF(#2)
    nIn = str2bin(UINT8,input$(1,#2))
    POKE VAR Memory64k(), nLineAdd, nIn
  INC nLineAdd
  LOOP
  close #2
  POKE VAR Memory64k(), nLineAdd, &H1A ' add CTRL Z to indicate end of CP/M file
end SUB

SUB RedrawScreen
' do if message box etc used
  GUI REDRAW ALL
  DrawRegisters
  gnFlagUpdateDisplay = UPDATE_ALL_DISPLAY
  UpdateRegistersDisplay
end sub

SUB LoadHexFile FileName AS STRING
' will convert a HEX file to a memory image
' Hex file address is BIG endian, Z80 is Little endian (LSB at lowest address)
  LOCAL as STRING StrIn
  LOCAL as INTEGER nByteCnt
  LOCAL AS INTEGER nMsgRet
  LOCAL AS INTEGER nCheckSum
  LOCAL AS INTEGER nBCnt=4 ' four bytes in
  LOCAL AS INTEGER nTemp
  LOCAL AS INTEGER nLineAdd
  LOCAL as INTEGER nData
  ON ERROR SKIP 1
  OPEN FileName FOR INPUT AS #2
  if MM.ERRNO <> 0 then
    WarnUserMsg "ERROR FILE COULD NOT BE OPENED", "CHECK FILE NAME"
    RedrawScreen
    EXIT SUB ' error
  endif
  Do ' the whole file
    LINE INPUT #2, StrIn
    nCheckSum = 0
    if LEFT$( StrIn, 1 ) <> ":" then
      WarnUserMsg "THIS IS NOT A INTL HEX FILE", "ENTER A HEX FILE"
      RedrawScreen
      EXIT DO
    end if
    ' now extract data from line and store
    nByteCnt = VAL("&H"+MID$(StrIn, 2, 2 ))
    nCheckSum = nCheckSum + nByteCnt
    nLineAdd = VAL("&H"+MID$(StrIn, 6, 2 )) ' lsb
    nCheckSum = nCheckSum + nLineAdd
    nTemp = VAL("&H"+MID$(StrIn, 4, 2 )) 'msb is lower address
    nCheckSum = nCheckSum + nTemp
    nLineAdd = nLineAdd + (nTemp << 8)
    nTemp = VAL("&H"+MID$(StrIn, 8, 2 )) 'type
    nCheckSum = nCheckSum + nTemp
    if MID$(StrIn, 8, 2 ) = "00" then ' its data
      nTemp = 10 ' start of data in line
      for gnI = 1 to nByteCnt
       nData = VAL("&H"+MID$(StrIn, nTemp, 2 ))
       nCheckSum = nCheckSum + nData
        POKE VAR Memory64k(), nLineAdd, nData
        INC nLineAdd ' next store address
        INC nTemp,2
      NEXT gnI
      nCheckSum = (INV (nCheckSum AND &HFF)) + 1
      nCheckSum = nCheckSum AND &HFF
      nTemp = VAL("&H"+MID$(StrIn, nTemp, 2 )) 
      if nCheckSum <> nTemp THEN 
        WarnUserMsg "CHECK SUM ERROR", ""
        EXIT DO
      end if
    else if (MID$(StrIn, 8, 2 ) = "01") OR (MID$(StrIn, 2, 2 )= "00") then ' some CP/M assembler versions only use byte count of zero for EOF
      EXIT DO ' no more data
    END IF ' data line
    LOOP
  CLOSE #2
End SUB

SUB SetIntPins(Trap as integer, RST5_5 as integer, RST6_5 as integer, RST7_5 as integer, SID as integer, SOD as integer, IntTime as Integer )
  ' Sets int and SID & SOD pins, user to ensure pin number is valid. IntTime is microsecs between checking for an interrupt pin to go Hi
  Registers(2) = 0 ' reset
  Registers(2) = Trap 
  Registers(2) = Registers(2) OR  (RST5_5 << 8)
  Registers(2) = Registers(2) OR  (RST6_5 << 16)
  Registers(2) = Registers(2) OR  (RST7_5 << 24)
  Registers(2) = Registers(2) OR  (SID << 32)
  Registers(2) = Registers(2) OR  (SOD << 40)
  Registers(2) = Registers(2) OR  (IntTime << 48)
  if Trap <> 0 and Trap < 41 then setpin Trap, DIN
  if RST5_5 <> 0 and RST5_5 < 41 then setpin RST5_5, DIN
  if RST6_5 <> 0 and RST6_5 < 41 then setpin RST6_5, DIN
  if RST7_5 <> 0 and RST7_5 < 41 then setpin RST7_5, DIN
  if SID <> 0 and SID < 41 then setpin SID, DIN
  if SOD <> 0 and SOD < 41 then setpin SOD, DOUT
  
end SUB

SUB CreateDisk DiskNumber as INTEGER
' Note CPM_Disk_X.dat will be created if it does not exist as part of the program start up
' Disk number 1 = A, 2 = B etc etc, max 16 (P) but restricted to 4 by my BIOS
' File name is "CPM_Disk_" plus the Disk number offset by 64 so 1 = "A", e.g CPM_Disk_A.dat. File is a type dat.
' Creates a disk of 256,256 bytes long, see below
' The CP/M uses a file on the SD card as the disk
' CP/M Disk dimensions are:
' 77 Tracks
' 26 Sectors in a Track 
' Sectors are 128 bytes.
' A Block is 8 sectors (128 X 8 = 1024 Bytes, the minimum storage size).
' Disk contains a byte size made up of 128 bytes X 26 sectors X 77 tracks = 256,256Bytes.
' Note Directory Entries (64 X 32 byte or 2 Blocks) are at track 0, sector 1 to 16. 
' Note the skew factor is set to 1 to 1 (i.e the Translation Table in the DPH is 1234..26) as we dont have to worry about disk rotation time.
' CPM is not stored on the disk as it is loaded directly into CP/M RAM by MMBASIC when LOAD CPM button pressed.
' CP/M will start when the RUN button pressed as the PC is set to cold star boot at &HFA00 (in BIOS).
  LOCAL STRING sDiskName
  LOCAL INTEGER nData = 0
  LOCAL INTEGER nByte15 = 8
  LOCAL INTEGER lnDiskNumber =  DiskNumber
  lnDiskNumber = lnDiskNumber + 64
  sDiskName = "CPM_Disk_" + STRING$( 1, lnDiskNumber )
  sDiskName = sDiskName + ".dat"
  if MM.INFO(FILESIZE sDiskName) = -1 Then ' does not exist so create
	  'print DISK_SIZE
	  'print "nData Zero = ", BIN2STR$(uint64,nData)
	  OPEN sDiskName FOR OUTPUT AS #1
	  for gnI = 1 to DISK_SIZE ' fill it with zeroes
		PRINT #1, BIN2STR$(uint64,nData);
	  next gnI
	  CLOSE #1
	  ' now set FCB as empty (E5)
	  nData = &HE5
	  OPEN sDiskName FOR RANDOM AS #1
	  for gnI = 1 to 2048 STEP 32
		SEEK #1, gnI 'First FCB
		print #1,BIN2STR$(uint8,nData);
		SEEK #1, gnI+15 'Byte 15, 8 sectors per block
		print #1,BIN2STR$(uint8,nByte15);
	  next gnI
	  CLOSE #1
  end if
END SUB

SUB MMCB
' MMBasic call back from assembly program, to do any assembly requests
' will also manage CP/M disk requirments depending on setting of LSB_MMB_PARAM_INDEX
' Note the A disk is opened as # 1 in RANDOM mode as part of the program initialisation
  LOCAL INTEGER nTemp
  'LOCAL INTEGER DebugArr(40) 
  'LOCAL INTEGER DebugCtr 
  LOCAL STRING StrIn
  LOCAL INTEGER nData
 Select Case PEEK(VAR Registers(), LSB_MMB_PARAM_INDEX)
    case CPM_WARM_BOOT ' CTRL C in CP/M will come here
      ' The following allows a CTRL C to go to STEP MODE if DEBUG_FLAG (at &HFFFF) was set to &H44, can be handy to debug CP/M programs
      if PEEK(VAR Memory64k(), DEBUG_FLAG)= &H44 then
        POKE VAR Registers(), CTR_FLAGS_INDEX, (FLAG_INIT OR FLAG_STEP) ' force into step mode so it will return
        gnStepDebug = 1 ' set to one so return end of next instruction
      else ' Normal CP/M CTRL C
        LoadHexFile "CCP.HEX" ' reload in case transient program removed it (e.g. DDT )
      end if
    case CPM_HOME ' Disk to start
        SEEK #1, 1 ' first byte
        gnBytePos = 1
    case CPM_SEL_DISK ' A reg contains error on return
        ON ERROR SKIP 1
        CLOSE #1
        SELECT CASE PEEK(VAR Registers(), C_REG_INDEX)
          Case 0
          ON ERROR SKIP 1
          OPEN "CPM_Disk_A.dat" FOR RANDOM AS #1
          if MM.ERRNO <> 0 then
            POKE VAR Registers(), A_REG_INDEX, 99   'error        
          else
            POKE VAR Registers(), A_REG_INDEX, 0  
          endIF
          gnBytePos = 1
          Case 1
          ON ERROR SKIP 1
          OPEN "CPM_Disk_B.dat" FOR RANDOM AS #1
          if MM.ERRNO <> 0 then
            POKE VAR Registers(), A_REG_INDEX, 99   'error        
          else
            POKE VAR Registers(), A_REG_INDEX, 0  
          ENDIF
          gnBytePos = 1
          Case 2
          ON ERROR SKIP 1
          OPEN "CPM_Disk_C.dat" FOR RANDOM AS #1
          if MM.ERRNO <> 0 then
            POKE VAR Registers(), A_REG_INDEX, 99   'error        
          else
            POKE VAR Registers(), A_REG_INDEX, 0  
          ENDIF
          gnBytePos = 1
          Case 3
          ON ERROR SKIP 1
          OPEN "CPM_Disk_D.dat" FOR RANDOM AS #1
          if MM.ERRNO <> 0 then
            POKE VAR Registers(), A_REG_INDEX, &HFF   'error        
          else
            POKE VAR Registers(), A_REG_INDEX, 0 
          ENDIF
          gnBytePos = 1
      END SELECT  
      case CPM_MOVE_TO_TRACK ' Set Track, C Reg = track, max of 76 (0 to 76), will not SEEK to the byte location, need to select sector after
        gnCurrentTrack = PEEK(VAR Registers(), C_REG_INDEX)
        gnBytePos = 1
        if gnCurrentTrack > 76 THEN
          PRINT " SELECTED TRACK > 76"
        ENDIF
      CASE CPM_SETSEC ' Reg C contains sector, 1 to 26, will seek to correct location
'       gnCurrentSector = PEEK(VAR Registers(), C_REG_INDEX)
        if gnCurrentSector < 27 THEN
          gnBytePos = (gnCurrentTrack * 3328) + ((gnCurrentSector-1) * 128) + 1 'at correct byte 
          SEEK #1, gnBytePos
        ENDIF
      CASE CPM_READ_DISK ' read 128 bytes from current location, 
        SEEK #1, gnBytePos
        gnDAMAddress = PEEK(VAR Registers(), LSB_DMA_ADDRESS) OR  (PEEK(VAR Registers(), MSB_DMA_ADDRESS) << 8)
        for gnI = 0 to 127
          ON ERROR SKIP 1
          nData = str2bin(UINT8,input$(1,#1))  
         POKE VAR Memory64k(), gnI+gnDAMAddress, nData
         NEXT gnI
         if MM.ERRNO <> 0 then
          POKE VAR Registers(), A_REG_INDEX, 1   'error  
        else
          POKE VAR Registers(), A_REG_INDEX, 0  
        ENDIF  
     CASE CPM_WRITE_DISK
        SEEK #1, gnBytePos 
        gnDAMAddress = PEEK(VAR Registers(), LSB_DMA_ADDRESS) OR  (PEEK(VAR Registers(), MSB_DMA_ADDRESS) << 8)
        For gnI = 0 to 127
          ON ERROR SKIP 1
          print #1,BIN2STR$(uint8,PEEK(VAR Memory64k(), gnI + gnDAMAddress));
        next gnI 
        if MM.ERRNO <> 0 then
            POKE VAR Registers(), A_REG_INDEX, 1   'error        
          else
            POKE VAR Registers(), A_REG_INDEX, 0  
          ENDIF 
    case CPM_OPEN_EXPORT ' opens MMBasic file CPM_EXPORT 
				gnExpType	= PEEK(VAR Registers(), C_REG_INDEX)
        if gnExpType = 1 Then
          OPEN "CPM_EXPORT.txt" FOR OUTPUT AS #10
          if MM.ERRNO <> 0 then
            POKE VAR Registers(), A_REG_INDEX, &HFF   'error  
          else
            POKE VAR Registers(), A_REG_INDEX, 0  ' all OK
          endif
        else
        	OPEN "CPM_EXPORT.bin" FOR OUTPUT AS #10
          if MM.ERRNO <> 0 then
            POKE VAR Registers(), A_REG_INDEX, 1   'error  
          else
            POKE VAR Registers(), A_REG_INDEX, 0  ' all OK
          endif
        end if
		case CPM_TRANSFER_EXPORT ' transfers 128 bytes to CPM_EXPORT, A REG set to FF if EOF 
      nTemp = 0
      For gnI = 0 to 127
          if gnExpType = 1 Then
            if PEEK(VAR Memory64k(), gnI + &H80) = &H1A THEN 'End Of File
              nTemp = &HFF
              EXIT FOR
            endif
            if PEEK(VAR Memory64k(), gnI + &H80) > 0 then
            if (PEEK(VAR Memory64k(), gnI + &H80) = 13 AND PEEK(VAR Memory64k(), gnI + &H80+1) = 10) THEN
                PRINT #10,""
                INC gnI 'skip next
              else
                ON ERROR SKIP 1
                print #10,CHR$(PEEK(VAR Memory64k(), gnI + &H80)); ' its at default DMA 80h
              ENDIF 
            ENDIF ' its a zero
          Else 'BINARY, relies on CP/M to define end of file
              ON ERROR SKIP 1
              print #10,BIN2STR$(uint8,PEEK(VAR Memory64k(), gnI + &H80));
          ENDIF
			next gnI
      POKE VAR Registers(), A_REG_INDEX, nTemp ' 0 if not EOF else FF if EOF
 		case CPM_CLOSE_EXPORT ' close CPM_EXPORT 
      close #10
    Case MMB_PAGE_DISPLAY
      PAGE DISPLAY  PEEK(VAR Registers(), C_REG_INDEX) ' C reg is number
    CASE  MMB_PAGE_WRITE
      PAGE WRITE  PEEK(VAR Registers(), C_REG_INDEX) ' C reg is number
    case MMB_CLR 
      CLS
    case MMB_TEXT_OUT
      ' TEXT x, y, string$ ,[,alignment$] [, font] [, scale] ,[, c] [, bc]
			'HL pointing to memory location with 16 bits words for x,y, (5) Byte for Alignment ('L', 'C', 'R')
			'(6) Byte for 'T', 'M', 'B', (7) Byte for orientation ('N', 'V', 'I','U','D'
			'Byte for (8) Font, Byte for (9) Scale, 3 bytes for Colour and 3 bytes for background colour. 
      'DE points to a String terminated in 0
      Local Integer NX,NY, NFont, nScale,nFColour, nBColour
      LOCAL STRING sAlign
       gnI =  PEEK(VAR Registers(), E_REG_INDEX) + (PEEK(VAR Registers(), D_REG_INDEX) << 8)
      do 
        nTemp = PEEK(VAR Memory64k(), gnI)
        if nTemp = 0 then EXIT DO
        StrIn = StrIn + CHR$(nTemp)
        INC gnI
        if LEN(StrIn) > 250 then EXIT DO ' fail safe
      loop
      gnI =  PEEK(VAR Registers(), L_REG_INDEX) + (PEEK(VAR Registers(), H_REG_INDEX) << 8)
      NX = PEEK(VAR Memory64k(), gnI) + (PEEK(VAR Memory64k(), gnI + 1)<< 8)
      NY = PEEK(VAR Memory64k(), gnI+2) + (PEEK(VAR Memory64k(), gnI + 3)<< 8)
      nTemp = PEEK(VAR Memory64k(), gnI+4) 'LCR
      sAlign = CHR$(nTemp)
      nTemp = PEEK(VAR Memory64k(), gnI+5)'TMN
      sAlign = sAlign + CHR$(nTemp)  
      nTemp = PEEK(VAR Memory64k(), gnI+6) 'NVIUD
      sAlign = sAlign + CHR$(nTemp)   
      NFont = PEEK(VAR Memory64k(), gnI+7)
      nScale = PEEK(VAR Memory64k(), gnI+8)
      nFColour = PEEK(VAR Memory64k(), gnI+9) + (PEEK(VAR Memory64k(), gnI+10)<<8) + (PEEK(VAR Memory64k(), gnI+11)<<16)
      nBColour = PEEK(VAR Memory64k(), gnI+12) + (PEEK(VAR Memory64k(), gnI+13)<<8) + (PEEK(VAR Memory64k(), gnI+14)<<16)
      TEXT NX, NY, StrIn, sAlign, NFont,nScale, nFColour, nBColour 
    Case MMB_GET_TIME
    'Sets C Reg = seconds, B Reg = Mins, E Reg = Hrs
      StrIn = TIME$ 'HH:MM:SS
      POKE VAR Registers(), E_REG_INDEX, VAL( LEFT$( StrIn, 2 )) 'Hrs
      POKE VAR Registers(), B_REG_INDEX, VAL(MID$( StrIn$, 4, 2 )) 'Mins
      POKE VAR Registers(), C_REG_INDEX, VAL(RIGHT$( StrIn, 2 )) 'secs
     case MMB_SAVE_IMAGE
      SAVE IMAGE "Z80Prog.bmp"
    case MMB_TRACE_REG_STATUS
       ' print Status, This is the status before the instruction is performed
        PRINT GetInstString();
        'print next 2 bytes in brackets for info just in case their used by instruction
        nTemp = PEEK(VAR Registers(), PCREGHI_INDEX) << 8 
        nTemp = nTemp + PEEK(VAR Registers(), PCREGLO_INDEX)
        INC nTemp
        print " (";
        PRINT HEX$( PEEK(VAR Memory64k(), nTemp) ,2); 
        INC nTemp
        PRINT HEX$( PEEK(VAR Memory64k(), nTemp) ,2); 
        PRINT ") ";
        'Flags Reg
        if PEEK(VAR Registers(), FLAG_REG_INDEX) AND &H80 then
          PRINT "-";
        else
          PRINT "+"; 
        end if
        If PEEK(VAR Registers(), FLAG_REG_INDEX) AND &H40 then
          PRINT "Z";
        else
          PRINT "-"; 
        end if
        If PEEK(VAR Registers(), FLAG_REG_INDEX) AND &H10 then
          PRINT "H";
        else
          PRINT "-"; 
        end if
        If PEEK(VAR Registers(), FLAG_REG_INDEX) AND &H4 then
          PRINT "P";
        else
          PRINT "-"; 
        end if
        If PEEK(VAR Registers(), FLAG_REG_INDEX) AND &H2 then
          PRINT "n";
        else
          PRINT "-"; 
        end if
        If PEEK(VAR Registers(), FLAG_REG_INDEX) AND &H1 then
          PRINT "C   ";
        else
          PRINT "NC  "; 
        end if
       PRINT HEX$(PEEK(VAR Registers(), A_REG_INDEX) ,2); 'A REG
       PRINT "  ";
       PRINT HEX$(PEEK(VAR Registers(), B_REG_INDEX) ,2); 'BC REG
       PRINT HEX$(PEEK(VAR Registers(), C_REG_INDEX) ,2);
       PRINT "  ";
       PRINT HEX$(PEEK(VAR Registers(), D_REG_INDEX) ,2); 'DE REG
       PRINT HEX$(PEEK(VAR Registers(), E_REG_INDEX) ,2);
       PRINT "  ";
       PRINT HEX$(PEEK(VAR Registers(), H_REG_INDEX) ,2); 'HL REG
       PRINT HEX$(PEEK(VAR Registers(), L_REG_INDEX) ,2);
       PRINT "    ";
       PRINT HEX$(PEEK(VAR Registers(), IX_REG_MSB_INDEX) ,2); 'IX REG
       PRINT HEX$(PEEK(VAR Registers(), IX_REG_LSB_INDEX) ,2);
       PRINT "  ";
       PRINT HEX$(PEEK(VAR Registers(), IY_REG_MSB_INDEX) ,2); 'IY REG
       PRINT HEX$(PEEK(VAR Registers(), IY_REG_LSB_INDEX) ,2);
       PRINT "    ";
       PRINT HEX$(PEEK(VAR Registers(), SPREGHI_INDEX) ,2); 'SP REG
       PRINT HEX$(PEEK(VAR Registers(), SPREGLO_INDEX) ,2);
       nTemp = (PEEK(VAR Registers(), B_REG_INDEX)) << 8 OR PEEK(VAR Registers(), C_REG_INDEX)
       PRINT " ("+HEX$(PEEK(VAR Memory64k(), nTemp),2)+")"; 'what BC pointing to
       nTemp = (PEEK(VAR Registers(), D_REG_INDEX)) << 8 OR PEEK(VAR Registers(), E_REG_INDEX)
       PRINT " ("+HEX$(PEEK(VAR Memory64k(), nTemp),2)+")"; 'what DE pointing to
       nTemp = (PEEK(VAR Registers(), H_REG_INDEX)) << 8 OR PEEK(VAR Registers(), L_REG_INDEX)
       PRINT " ("+HEX$(PEEK(VAR Memory64k(), nTemp),2)+")" 'what HL pointing to
   END SELECT 
end SUB

Sub TouchDown
  gnLastButtonPressed = click(REF)
end sub

SUB SetDisplayLocArray
  LOCAL AS INTEGER nArrOffset, AltRegX
  DisplayLoc(FLAGS,TOPL_X) = D_X1
  DisplayLoc(FLAGS,TOPL_Y) = D_Y1 
  DisplayLoc(FLAGS,BOTR_X) = DisplayLoc(FLAGS,TOPL_X) + D_WIDTH
  DisplayLoc(FLAGS,BOTR_Y) = DisplayLoc(FLAGS,TOPL_Y) + D_HEIGHT

  DisplayLoc(IREG,TOPL_X) = D_X1+D_WIDTH+D_H_SPACE
  DisplayLoc(IREG,TOPL_Y) = D_Y1
  DisplayLoc(IREG,BOTR_X) = DisplayLoc(IREG,TOPL_X) + D_WIDTH
  DisplayLoc(IREG,BOTR_Y) = DisplayLoc(IREG,TOPL_Y) + D_HEIGHT
  DisplayLoc(AREG,TOPL_X) = D_X1
  DisplayLoc(AREG,TOPL_Y) = D_Y1+D_HEIGHT+D_V_SPACE 
  DisplayLoc(AREG,BOTR_X) = DisplayLoc(AREG,TOPL_X) + D_WIDTH
  DisplayLoc(AREG,BOTR_Y) = DisplayLoc(AREG,TOPL_Y) + D_HEIGHT
  AltRegX = D_X1+(BUTTON_WIDTH+D_H_SPACE)*7 + (BUTTON_WIDTH*4) + D_H_SPACE
  DisplayLoc(ALT_FLAGS,TOPL_X) = AltRegX
  DisplayLoc(ALT_FLAGS,TOPL_Y) = D_Y1 
  DisplayLoc(ALT_FLAGS,BOTR_X) = DisplayLoc(ALT_FLAGS,TOPL_X) + D_WIDTH
  DisplayLoc(ALT_FLAGS,BOTR_Y) = DisplayLoc(ALT_FLAGS,TOPL_Y) + D_HEIGHT
  DisplayLoc(ALT_AREG,TOPL_X) = AltRegX
  DisplayLoc(ALT_AREG,TOPL_Y) = D_Y1+D_HEIGHT+D_V_SPACE 
  DisplayLoc(ALT_AREG,BOTR_X) = DisplayLoc(ALT_AREG,TOPL_X) + D_WIDTH
  DisplayLoc(ALT_AREG,BOTR_Y) = DisplayLoc(ALT_AREG,TOPL_Y) + D_HEIGHT
  nArrOffset = 2

  DisplayLoc(BREG,TOPL_X) = D_X1
  DisplayLoc(BREG,TOPL_Y) = D_Y1+ (nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(BREG,BOTR_X) = DisplayLoc(BREG,TOPL_X) + D_WIDTH
  DisplayLoc(BREG,BOTR_Y) = DisplayLoc(BREG,TOPL_Y) + D_HEIGHT
  DisplayLoc(CREg,TOPL_X) = D_X1+D_WIDTH+D_H_SPACE
  DisplayLoc(CREg,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(CREg,BOTR_X) = DisplayLoc(BREG,TOPL_X) + D_WIDTH
  DisplayLoc(CREg,BOTR_Y) = DisplayLoc(BREG,TOPL_Y) + D_HEIGHT
  DisplayLoc(ALT_BREG,TOPL_X) = AltRegX
  DisplayLoc(ALT_BREG,TOPL_Y) = D_Y1+ (nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(ALT_BREG,BOTR_X) = DisplayLoc(ALT_BREG,TOPL_X) + D_WIDTH
  DisplayLoc(ALT_BREG,BOTR_Y) = DisplayLoc(ALT_BREG,TOPL_Y) + D_HEIGHT
  DisplayLoc(ALT_CREg,TOPL_X) = AltRegX+D_WIDTH+D_H_SPACE
  DisplayLoc(ALT_CREg,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(ALT_CREg,BOTR_X) = DisplayLoc(ALT_BREG,TOPL_X) + D_WIDTH
  DisplayLoc(ALT_CREg,BOTR_Y) = DisplayLoc(ALT_BREG,TOPL_Y) + D_HEIGHT

  Inc nArrOffset
  DisplayLoc(DREG,TOPL_X) = D_X1
  DisplayLoc(DREG,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(DREG,BOTR_X) = DisplayLoc(DREG,TOPL_X) + D_WIDTH
  DisplayLoc(DREG,BOTR_Y) = DisplayLoc(DREG,TOPL_Y) + D_HEIGHT
  DisplayLoc(EREG,TOPL_X) = D_X1+D_WIDTH+D_H_SPACE
  DisplayLoc(EREG,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(EREG,BOTR_X) = DisplayLoc(EREG,TOPL_X) + D_WIDTH
  DisplayLoc(EREG,BOTR_Y) = DisplayLoc(EREG,TOPL_Y) + D_HEIGHT
  DisplayLoc(ALT_DREG,TOPL_X) = AltRegX
  DisplayLoc(ALT_DREG,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(ALT_DREG,BOTR_X) = DisplayLoc(ALT_DREG,TOPL_X) + D_WIDTH
  DisplayLoc(ALT_DREG,BOTR_Y) = DisplayLoc(ALT_DREG,TOPL_Y) + D_HEIGHT
  DisplayLoc(ALT_EREG,TOPL_X) = AltRegX+D_WIDTH+D_H_SPACE
  DisplayLoc(ALT_EREG,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(ALT_EREG,BOTR_X) = DisplayLoc(ALT_EREG,TOPL_X) + D_WIDTH
  DisplayLoc(ALT_EREG,BOTR_Y) = DisplayLoc(ALT_EREG,TOPL_Y) + D_HEIGHT

  Inc nArrOffset
  DisplayLoc(HREG,TOPL_X) = D_X1
  DisplayLoc(HREG,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(HREG,BOTR_X) = DisplayLoc(HREG,TOPL_X) + D_WIDTH
  DisplayLoc(HREG,BOTR_Y) = DisplayLoc(HREG,TOPL_Y) + D_HEIGHT
  DisplayLoc(LREG,TOPL_X) = D_X1+D_WIDTH+D_H_SPACE
  DisplayLoc(LREG,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(LREG,BOTR_X) = DisplayLoc(LREG,TOPL_X) + D_WIDTH
  DisplayLoc(LREG,BOTR_Y) = DisplayLoc(LREG,TOPL_Y) + D_HEIGHT
  DisplayLoc(ALT_HREG,TOPL_X) = AltRegX
  DisplayLoc(ALT_HREG,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(ALT_HREG,BOTR_X) = DisplayLoc(ALT_HREG,TOPL_X) + D_WIDTH
  DisplayLoc(ALT_HREG,BOTR_Y) = DisplayLoc(ALT_HREG,TOPL_Y) + D_HEIGHT
  DisplayLoc(ALT_LREG,TOPL_X) = AltRegX+D_WIDTH+D_H_SPACE
  DisplayLoc(ALT_LREG,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(ALT_LREG,BOTR_X) = DisplayLoc(ALT_LREG,TOPL_X) + D_WIDTH
  DisplayLoc(ALT_LREG,BOTR_Y) = DisplayLoc(ALT_LREG,TOPL_Y) + D_HEIGHT

  INC nArrOffset
  DisplayLoc(SPREG,TOPL_X) = D_X1
  DisplayLoc(SPREG,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(SPREG,BOTR_X) = DisplayLoc(SPREG,TOPL_X) + (2*D_WIDTH) + D_H_SPACE
  DisplayLoc(SPREG,BOTR_Y) = DisplayLoc(SPREG,TOPL_Y) + D_HEIGHT
  DisplayLoc(IX_REG,TOPL_X) = AltRegX
  DisplayLoc(IX_REG,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(IX_REG,BOTR_X) = DisplayLoc(IX_REG,TOPL_X) + (2*D_WIDTH) + D_H_SPACE
  DisplayLoc(IX_REG,BOTR_Y) = DisplayLoc(IX_REG,TOPL_Y) + D_HEIGHT
  INC nArrOffset
  DisplayLoc(PCREG,TOPL_X) = D_X1
  DisplayLoc(PCREG,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(PCREG,BOTR_X) = DisplayLoc(PCREG,TOPL_X) + (2*D_WIDTH) + D_H_SPACE
  DisplayLoc(PCREG,BOTR_Y) = DisplayLoc(PCREG,TOPL_Y) + D_HEIGHT
  DisplayLoc(IY_REG,TOPL_X) = AltRegX
  DisplayLoc(IY_REG,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(IY_REG,BOTR_X) = DisplayLoc(IY_REG,TOPL_X) + (2*D_WIDTH) + D_H_SPACE
  DisplayLoc(IY_REG,BOTR_Y) = DisplayLoc(IY_REG,TOPL_Y) + D_HEIGHT

  INC nArrOffset
  INC nArrOffset
  DisplayLoc(ADDRESS_DISPLAY,TOPL_X) = D_X1
  DisplayLoc(ADDRESS_DISPLAY,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(ADDRESS_DISPLAY,BOTR_X) = DisplayLoc(ADDRESS_DISPLAY,TOPL_X) + D_WIDTH
  DisplayLoc(ADDRESS_DISPLAY,BOTR_Y) = DisplayLoc(ADDRESS_DISPLAY,TOPL_Y) + D_HEIGHT
  'INC nArrOffset
  DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_X) = D_X1+D_WIDTH+D_H_SPACE
  DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(MEMORY_BYTE_DISPLAY,BOTR_X) = DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_X) + D_WIDTH/2
  DisplayLoc(MEMORY_BYTE_DISPLAY,BOTR_Y) = DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_Y) + D_HEIGHT
  DisplayLoc(STEP_DISPLAY,TOPL_X) = D_X1+D_WIDTH+D_H_SPACE + D_WIDTH/2+D_H_SPACE
  DisplayLoc(STEP_DISPLAY,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(STEP_DISPLAY,BOTR_X) = DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_X) + D_WIDTH/2
  DisplayLoc(STEP_DISPLAY,BOTR_Y) = DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_Y) + D_HEIGHT
  INC nArrOffset
  INC nArrOffset
  DisplayLoc(USER_DISPLAY,TOPL_X) = D_X1
  DisplayLoc(USER_DISPLAY,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(USER_DISPLAY,BOTR_X) = DisplayLoc(USER_DISPLAY,TOPL_X) + D_WIDTH
  DisplayLoc(USER_DISPLAY,BOTR_Y) = DisplayLoc(USER_DISPLAY,TOPL_Y) + D_HEIGHT

  DisplayLoc(RUN_TO_DISPLAY,TOPL_X) = D_X1+D_WIDTH+D_H_SPACE
  DisplayLoc(RUN_TO_DISPLAY,TOPL_Y) = D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  DisplayLoc(RUN_TO_DISPLAY,BOTR_X) = DisplayLoc(USER_DISPLAY,TOPL_X) + D_WIDTH
  DisplayLoc(RUN_TO_DISPLAY,BOTR_Y) = DisplayLoc(USER_DISPLAY,TOPL_Y) + D_HEIGHT

  ' button matrix
  'first row
  INC nArrOffset
  INC nArrOffset
  ButtonMatrix_X(0)=D_X1 'C
  ButtonMatrix_Y(0)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ButtonMatrix_X(1)=ButtonMatrix_X(0)+BUTTON_WIDTH+D_H_SPACE'D
  ButtonMatrix_Y(1)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ButtonMatrix_X(2)=ButtonMatrix_X(0)+(BUTTON_WIDTH+D_H_SPACE)*2'E
  ButtonMatrix_Y(2)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ButtonMatrix_X(3)=ButtonMatrix_X(0)+(BUTTON_WIDTH+D_H_SPACE)*3'F
  ButtonMatrix_Y(3)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ' Address INC Button
  ButtonMatrix_X(16)=ButtonMatrix_X(0)+(BUTTON_WIDTH+D_H_SPACE)*4'F
  ButtonMatrix_Y(16)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ' STEP Button
  ButtonMatrix_X(20)=ButtonMatrix_X(0)+(BUTTON_WIDTH+D_H_SPACE)*7 ' have space
  ButtonMatrix_Y(20)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ' Load CP/M System Button
  ButtonMatrix_X(24)=ButtonMatrix_X(20)+ (BUTTON_WIDTH*4) + D_H_SPACE 
  ButtonMatrix_Y(24)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))

  'second row
  INC nArrOffset
  ButtonMatrix_X(4)=D_X1 '8
  ButtonMatrix_Y(4)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ButtonMatrix_X(5)=ButtonMatrix_X(0)+BUTTON_WIDTH+D_H_SPACE'9
  ButtonMatrix_Y(5)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ButtonMatrix_X(6)=ButtonMatrix_X(0)+(BUTTON_WIDTH+D_H_SPACE)*2'A
  ButtonMatrix_Y(6)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ButtonMatrix_X(7)=ButtonMatrix_X(0)+(BUTTON_WIDTH+D_H_SPACE)*3'B
  ButtonMatrix_Y(7)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ' DEC Sel Button
  ButtonMatrix_X(17)=ButtonMatrix_X(0)+(BUTTON_WIDTH+D_H_SPACE)*4
  ButtonMatrix_Y(17)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  'RUN TO Button
  ButtonMatrix_X(23)=ButtonMatrix_X(0)+(BUTTON_WIDTH+D_H_SPACE)*7
  ButtonMatrix_Y(23)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ' Load fILE Button
  ButtonMatrix_X(25)=ButtonMatrix_X(23)+ (BUTTON_WIDTH*4) + D_H_SPACE 
  ButtonMatrix_Y(25)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))

  'third row
  INC nArrOffset
  ButtonMatrix_X(8)=D_X1 '4
  ButtonMatrix_Y(8)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ButtonMatrix_X(9)=ButtonMatrix_X(0)+BUTTON_WIDTH+D_H_SPACE'5
  ButtonMatrix_Y(9)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ButtonMatrix_X(10)=ButtonMatrix_X(0)+(BUTTON_WIDTH+D_H_SPACE)*2'6
  ButtonMatrix_Y(10)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ButtonMatrix_X(11)=ButtonMatrix_X(0)+(BUTTON_WIDTH+D_H_SPACE)*3'7
  ButtonMatrix_Y(11)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  'OK Button
  ButtonMatrix_X(18)=ButtonMatrix_X(0)+(BUTTON_WIDTH+D_H_SPACE)*4
  ButtonMatrix_Y(18)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ' RUN Sel Button
  ButtonMatrix_X(21)=ButtonMatrix_X(0)+(BUTTON_WIDTH+D_H_SPACE)*7
  ButtonMatrix_Y(21)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ' Load hex fILE Button
  ButtonMatrix_X(26)=ButtonMatrix_X(21)+ (BUTTON_WIDTH*4) + D_H_SPACE 
  ButtonMatrix_Y(26)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))

  'forth row
  INC nArrOffset
  ButtonMatrix_X(12)=D_X1 '0
  ButtonMatrix_Y(12)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ButtonMatrix_X(13)=ButtonMatrix_X(0)+BUTTON_WIDTH+D_H_SPACE'1
  ButtonMatrix_Y(13)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ButtonMatrix_X(14)=ButtonMatrix_X(0)+(BUTTON_WIDTH+D_H_SPACE)*2'2
  ButtonMatrix_Y(14)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ButtonMatrix_X(15)=ButtonMatrix_X(0)+(BUTTON_WIDTH+D_H_SPACE)*3'3
  ButtonMatrix_Y(15)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  'RESET Button
  ButtonMatrix_X(19)=ButtonMatrix_X(0)+(BUTTON_WIDTH+D_H_SPACE)*4
  ButtonMatrix_Y(19)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  'EXIT Button
  ButtonMatrix_X(22)=ButtonMatrix_X(0)+(BUTTON_WIDTH+D_H_SPACE)*7
  ButtonMatrix_Y(22)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ' zero memory Button
  ButtonMatrix_X(27)=ButtonMatrix_X(22)+ (BUTTON_WIDTH*4) + D_H_SPACE 
  ButtonMatrix_Y(27)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))
  ' Log Button
  ButtonMatrix_X(28)=ButtonMatrix_X(27)+ (BUTTON_WIDTH*4) + D_H_SPACE 
  ButtonMatrix_Y(28)=D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))

  'Fifth Row
  INC nArrOffset
  INC nArrOffset
  MiscLoc_X(0)= ButtonMatrix_X(0)+ (BUTTON_WIDTH+D_H_SPACE)*7
  MiscLoc_Y(0)= D_Y1+(nArrOffset*(D_HEIGHT+D_V_SPACE))+ D_V_SPACE
  ' Main Frame
  MiscLoc_X(1)= DisplayLoc(FLAGS,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)*6)
MiscLoc_Y(1)= MM.INFO(FONTHEIGHT) 'DisplayLoc(IREG,TOPL_Y)- (MM.INFO(FONTHEIGHT)*3)
END SUB

SUB DrawRegisters
  BOX DisplayLoc(FLAGS,TOPL_X), DisplayLoc(FLAGS,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'FLAGS
  BOX DisplayLoc(IREG,TOPL_X), DisplayLoc(IREG,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'IREG 
  BOX DisplayLoc(AREG,TOPL_X), DisplayLoc(AREG,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'A
  BOX DisplayLoc(BREG,TOPL_X), DisplayLoc(BREG,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'B
  BOX DisplayLoc(CREG,TOPL_X), DisplayLoc(CREg,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'C
  BOX DisplayLoc(DREG,TOPL_X), DisplayLoc(DREG,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'D
  BOX DisplayLoc(EREG,TOPL_X), DisplayLoc(EREG,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'E
  BOX DisplayLoc(HREG,TOPL_X), DisplayLoc(HREG,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'H
  BOX DisplayLoc(LREG,TOPL_X), DisplayLoc(LREG,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'L
  BOX DisplayLoc(SPREG,TOPL_X), DisplayLoc(SPREG,TOPL_Y), (2*D_WIDTH) + D_H_SPACE, D_HEIGHT, D_THICKNESS, D_COLOUR 'SP
  BOX DisplayLoc(PCREG,TOPL_X), DisplayLoc(PCREG,TOPL_Y), (2*D_WIDTH) + D_H_SPACE, D_HEIGHT, D_THICKNESS, D_COLOUR 'PC
  BOX DisplayLoc(ADDRESS_DISPLAY,TOPL_X), DisplayLoc(ADDRESS_DISPLAY,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'Address
  BOX DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_X), DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_Y), D_WIDTH/2, D_HEIGHT, D_THICKNESS, D_COLOUR 'memory data
  BOX DisplayLoc(STEP_DISPLAY,TOPL_X), DisplayLoc(STEP_DISPLAY,TOPL_Y), D_WIDTH/2, D_HEIGHT, D_THICKNESS, D_COLOUR 'step size
  BOX DisplayLoc(USER_DISPLAY,TOPL_X), DisplayLoc(USER_DISPLAY,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'memory data
  BOX DisplayLoc(RUN_TO_DISPLAY,TOPL_X), DisplayLoc(RUN_TO_DISPLAY,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'run to
  
  BOX DisplayLoc(ALT_FLAGS,TOPL_X), DisplayLoc(ALT_FLAGS,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'FLAGS
  BOX DisplayLoc(ALT_AREG,TOPL_X), DisplayLoc(ALT_AREG,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'A
  BOX DisplayLoc(ALT_BREG,TOPL_X), DisplayLoc(ALT_BREG,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'B
  BOX DisplayLoc(ALT_CREG,TOPL_X), DisplayLoc(ALT_CREg,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'C
  BOX DisplayLoc(ALT_DREG,TOPL_X), DisplayLoc(ALT_DREG,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'D
  BOX DisplayLoc(ALT_EREG,TOPL_X), DisplayLoc(ALT_EREG,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'E
  BOX DisplayLoc(ALT_HREG,TOPL_X), DisplayLoc(ALT_HREG,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'H
  BOX DisplayLoc(ALT_LREG,TOPL_X), DisplayLoc(ALT_LREG,TOPL_Y), D_WIDTH, D_HEIGHT, D_THICKNESS, D_COLOUR 'L
  BOX DisplayLoc(IX_REG,TOPL_X), DisplayLoc(IX_REG,TOPL_Y), (2*D_WIDTH) + D_H_SPACE, D_HEIGHT, D_THICKNESS, D_COLOUR 'SP
  BOX DisplayLoc(IY_REG,TOPL_X), DisplayLoc(IY_REG,TOPL_Y), (2*D_WIDTH) + D_H_SPACE, D_HEIGHT, D_THICKNESS, D_COLOUR 'PC
  BOX MiscLoc_X(0), MiscLoc_Y(0), FILENAME_IN_WIDTH, D_HEIGHT, 2, RGB(WHITE) ' file in
  TEXT MiscLoc_X(0)+4, MiscLoc_Y(0)+MM.INFO(FONTHEIGHT) + 4, gsFileName,"LBN",1,1,RGB(RED)
   
  ' Reg labels
  TEXT DisplayLoc(FLAGS,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)), DisplayLoc(FLAGS,TOPL_Y) + L_Y_OFFSET, "F", "LMN", 1,1,L_COLOUR
  DrawCharHat DisplayLoc(FLAGS,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)), DisplayLoc(FLAGS,TOPL_Y) + L_Y_OFFSET,1,1,1
  TEXT DisplayLoc(IREG,TOPL_X)+ D_WIDTH + L_X_OFFSET), DisplayLoc(IREG,TOPL_Y) + L_Y_OFFSET, "I", "LMN", 1,1,L_COLOUR
  DrawCharHat DisplayLoc(IREG,TOPL_X)+ D_WIDTH + L_X_OFFSET), DisplayLoc(IREG,TOPL_Y) + L_Y_OFFSET,1,1,1
  TEXT DisplayLoc(AREG,TOPL_X)- L_X_OFFSET - MM.INFO(FONTWIDTH), DisplayLoc(AREG,TOPL_Y) + L_Y_OFFSET, "A", "LMN", 1,1,L_COLOUR
  DrawCharHat DisplayLoc(AREG,TOPL_X)- L_X_OFFSET - MM.INFO(FONTWIDTH), DisplayLoc(AREG,TOPL_Y) + L_Y_OFFSET,1,1,1
  TEXT DisplayLoc(BREG,TOPL_X)- L_X_OFFSET - MM.INFO(FONTWIDTH), DisplayLoc(BREG,TOPL_Y) + L_Y_OFFSET, "B", "LMN", 1,1,L_COLOUR
  DrawCharHat DisplayLoc(BREG,TOPL_X)- L_X_OFFSET - MM.INFO(FONTWIDTH), DisplayLoc(BREG,TOPL_Y) + L_Y_OFFSET,1,1,1
  TEXT DisplayLoc(CREg,TOPL_X)+ D_WIDTH + L_X_OFFSET, DisplayLoc(CREg,TOPL_Y) + L_Y_OFFSET, "C", "LMN", 1,1,L_COLOUR  
  DrawCharHat DisplayLoc(CREg,TOPL_X)+ D_WIDTH + L_X_OFFSET, DisplayLoc(CREg,TOPL_Y) + L_Y_OFFSET,1,1,1
  TEXT DisplayLoc(DREG,TOPL_X)- L_X_OFFSET - MM.INFO(FONTWIDTH), DisplayLoc(DREG,TOPL_Y) + L_Y_OFFSET, "D", "LMN", 1,1,L_COLOUR
  DrawCharHat DisplayLoc(DREG,TOPL_X)- L_X_OFFSET - MM.INFO(FONTWIDTH), DisplayLoc(DREG,TOPL_Y) + L_Y_OFFSET,1,1,1
  TEXT DisplayLoc(EREG,TOPL_X)+ D_WIDTH+ L_X_OFFSET, DisplayLoc(EREG,TOPL_Y) + L_Y_OFFSET, "E", "LMN", 1,1,L_COLOUR
  DrawCharHat DisplayLoc(EREG,TOPL_X)+ D_WIDTH+ L_X_OFFSET, DisplayLoc(EREG,TOPL_Y) + L_Y_OFFSET,1,1,1
  TEXT DisplayLoc(HREG,TOPL_X)- L_X_OFFSET - MM.INFO(FONTWIDTH), DisplayLoc(HREG,TOPL_Y) + L_Y_OFFSET, "H", "LMN", 1,1,L_COLOUR
  DrawCharHat DisplayLoc(HREG,TOPL_X)- L_X_OFFSET - MM.INFO(FONTWIDTH), DisplayLoc(HREG,TOPL_Y) + L_Y_OFFSET,1,1,1
  TEXT DisplayLoc(LREG,TOPL_X)+ D_WIDTH+ L_X_OFFSET, DisplayLoc(LREG,TOPL_Y) + L_Y_OFFSET, "L", "LMN", 1,1,L_COLOUR
  DrawCharHat DisplayLoc(LREG,TOPL_X)+ D_WIDTH+ L_X_OFFSET, DisplayLoc(LREG,TOPL_Y) + L_Y_OFFSET,1,1,1
  TEXT DisplayLoc(SPREG,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)*2), DisplayLoc(SPREG,TOPL_Y) + L_Y_OFFSET, "SP", "LMN", 1,1,L_COLOUR
  TEXT DisplayLoc(PCREG,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)*2), DisplayLoc(PCREG,TOPL_Y) + L_Y_OFFSET, "PC", "LMN", 1,1,L_COLOUR
  TEXT DisplayLoc(ADDRESS_DISPLAY,TOPL_X)+D_WIDTH/2, DisplayLoc(ADDRESS_DISPLAY,TOPL_Y) - L_Y_OFFSET/1.5, "ADDRESS", "CMN", 1,1,L_COLOUR
  DrawCharHat DisplayLoc(ADDRESS_DISPLAY,TOPL_X)+D_WIDTH/2, DisplayLoc(ADDRESS_DISPLAY,TOPL_Y) - L_Y_OFFSET/1.5,6,7,2
  TEXT MiscLoc_X(0)+FILENAME_IN_WIDTH/2, MiscLoc_Y(0) - L_Y_OFFSET/1.5, "FILE NAME", "CMN", 1,1,L_COLOUR
  DrawCharHat MiscLoc_X(0)+FILENAME_IN_WIDTH/2, MiscLoc_Y(0) - L_Y_OFFSET/1.5,6,9,2
  
  TEXT DisplayLoc(ALT_FLAGS,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)*2), DisplayLoc(ALT_FLAGS,TOPL_Y) + L_Y_OFFSET, "F'", "LMN", 1,1,L_COLOUR
  TEXT DisplayLoc(ALT_AREG,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)*2), DisplayLoc(ALT_AREG,TOPL_Y) + L_Y_OFFSET, "A'", "LMN", 1,1,L_COLOUR
  TEXT DisplayLoc(ALT_BREG,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)*2), DisplayLoc(ALT_BREG,TOPL_Y) + L_Y_OFFSET, "B'", "LMN", 1,1,L_COLOUR
  TEXT DisplayLoc(ALT_CREg,TOPL_X)+ D_WIDTH + L_X_OFFSET, DisplayLoc(ALT_CREG,TOPL_Y) + L_Y_OFFSET, "C'", "LMN", 1,1,L_COLOUR
  TEXT DisplayLoc(ALT_DREG,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)*2), DisplayLoc(ALT_DREG,TOPL_Y) + L_Y_OFFSET, "D'", "LMN", 1,1,L_COLOUR
  TEXT DisplayLoc(ALT_EREG,TOPL_X)+ D_WIDTH+ L_X_OFFSET, DisplayLoc(ALT_EREG,TOPL_Y) + L_Y_OFFSET, "E'", "LMN", 1,1,L_COLOUR
  TEXT DisplayLoc(ALT_HREG,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)*2), DisplayLoc(ALT_HREG,TOPL_Y) + L_Y_OFFSET, "H'", "LMN", 1,1,L_COLOUR
  TEXT DisplayLoc(ALT_LREG,TOPL_X)+ D_WIDTH+ L_X_OFFSET, DisplayLoc(ALT_LREG,TOPL_Y) + L_Y_OFFSET, "L'", "LMN", 1,1,L_COLOUR
  TEXT DisplayLoc(IX_REG,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)*2), DisplayLoc(IX_REG,TOPL_Y) + L_Y_OFFSET, "IX", "LMN", 1,1,L_COLOUR
  DrawCharHat DisplayLoc(IX_REG,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)*2), DisplayLoc(IX_REG,TOPL_Y) + L_Y_OFFSET,2,2,1
  TEXT DisplayLoc(IY_REG,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)*2), DisplayLoc(IY_REG,TOPL_Y) + L_Y_OFFSET, "IY", "LMN", 1,1,L_COLOUR
  DrawCharHat DisplayLoc(IY_REG,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)*2), DisplayLoc(IY_REG,TOPL_Y) + L_Y_OFFSET,2,2,1

  TEXT DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_X)+D_WIDTH/4, DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_Y) - L_Y_OFFSET/1.5, "MEMORY", "CMN", 1,1,L_COLOUR
  DrawCharHat DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_X)+D_WIDTH/4, DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_Y) - L_Y_OFFSET/1.5,1,6,2
  TEXT DisplayLoc(STEP_DISPLAY,TOPL_X)+D_WIDTH/4, DisplayLoc(STEP_DISPLAY,TOPL_Y) - L_Y_OFFSET/1.5, "STEP", "CMN", 1,1,L_COLOUR
  DrawCharHat DisplayLoc(STEP_DISPLAY,TOPL_X)+D_WIDTH/4, DisplayLoc(STEP_DISPLAY,TOPL_Y) - L_Y_OFFSET/1.5,4,4,2
  TEXT DisplayLoc(USER_DISPLAY,TOPL_X)+D_WIDTH/2, DisplayLoc(USER_DISPLAY,TOPL_Y) - L_Y_OFFSET/1.5, "USER INPUT", "CMN", 1,1,L_COLOUR
  TEXT DisplayLoc(RUN_TO_DISPLAY,TOPL_X)+D_WIDTH/2, DisplayLoc(RUN_TO_DISPLAY,TOPL_Y) - L_Y_OFFSET/1.5, "STOP ADDRESS", "CMN", 1,1,L_COLOUR
  DrawCharHat DisplayLoc(RUN_TO_DISPLAY,TOPL_X)+D_WIDTH/2, DisplayLoc(RUN_TO_DISPLAY,TOPL_Y) - L_Y_OFFSET/1.5,3,12,2

  'FLAGS Labels
  TEXT DisplayLoc(FLAGS,TOPL_X)+ (MM.INFO(FONTWIDTH)*4), DisplayLoc(FLAGS,TOPL_Y), "S", "CBN", 1,1,L_COLOUR
  TEXT DisplayLoc(FLAGS,TOPL_X)+ (MM.INFO(FONTWIDTH)*5), DisplayLoc(FLAGS,TOPL_Y), "Z", "CBN", 1,1,L_COLOUR
  'TEXT DisplayLoc(FLAGS,TOPL_X)+ (MM.INFO(FONTWIDTH)*7), DisplayLoc(FLAGS,TOPL_Y) - MM.INFO(FONTHEIGHT), "A", "CTN", 1,1,L_COLOUR
  TEXT DisplayLoc(FLAGS,TOPL_X)+ (MM.INFO(FONTWIDTH)*7), DisplayLoc(FLAGS,TOPL_Y), "H", "CBN", 1,1,L_COLOUR
  TEXT DisplayLoc(FLAGS,TOPL_X)+ (MM.INFO(FONTWIDTH)*9), DisplayLoc(FLAGS,TOPL_Y), "P", "CBN", 1,1,L_COLOUR
  TEXT DisplayLoc(FLAGS,TOPL_X)+ (MM.INFO(FONTWIDTH)*10), DisplayLoc(FLAGS,TOPL_Y), "N", "CBN", 1,1,L_COLOUR
  TEXT DisplayLoc(FLAGS,TOPL_X)+ (MM.INFO(FONTWIDTH)*11), DisplayLoc(FLAGS,TOPL_Y), "C", "CBN", 1,1,L_COLOUR
  TEXT DisplayLoc(ALT_FLAGS,TOPL_X)+ (MM.INFO(FONTWIDTH)*4), DisplayLoc(ALT_FLAGS,TOPL_Y), "S", "CBN", 1,1,L_COLOUR
  TEXT DisplayLoc(ALT_FLAGS,TOPL_X)+ (MM.INFO(FONTWIDTH)*5), DisplayLoc(ALT_FLAGS,TOPL_Y), "Z", "CBN", 1,1,L_COLOUR
  'TEXT DisplayLoc(ALT_FLAGS,TOPL_X)+ (MM.INFO(FONTWIDTH)*7), DisplayLoc(ALT_FLAGS,TOPL_Y) - MM.INFO(FONTHEIGHT), "A", "CTN", 1,1,L_COLOUR
  TEXT DisplayLoc(ALT_FLAGS,TOPL_X)+ (MM.INFO(FONTWIDTH)*7), DisplayLoc(ALT_FLAGS,TOPL_Y), "H", "CBN", 1,1,L_COLOUR
  TEXT DisplayLoc(ALT_FLAGS,TOPL_X)+ (MM.INFO(FONTWIDTH)*9), DisplayLoc(ALT_FLAGS,TOPL_Y), "P", "CBN", 1,1,L_COLOUR
  TEXT DisplayLoc(ALT_FLAGS,TOPL_X)+ (MM.INFO(FONTWIDTH)*10), DisplayLoc(ALT_FLAGS,TOPL_Y), "N", "CBN", 1,1,L_COLOUR
  TEXT DisplayLoc(ALT_FLAGS,TOPL_X)+ (MM.INFO(FONTWIDTH)*11), DisplayLoc(ALT_FLAGS,TOPL_Y), "C", "CBN", 1,1,L_COLOUR
 
end SUB

SUB DrawDisplay

  DrawRegisters
  'Area
  GUI AREA A_FLAGS, DisplayLoc(FLAGS,TOPL_X), DisplayLoc(FLAGS,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_IREG, DisplayLoc(IREG,TOPL_X), DisplayLoc(IREG,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_AREG, DisplayLoc(AREG,TOPL_X), DisplayLoc(AREG,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_BREG, DisplayLoc(BREG,TOPL_X), DisplayLoc(BREG,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_CREG, DisplayLoc(CREG,TOPL_X), DisplayLoc(CREg,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_DREG, DisplayLoc(DREG,TOPL_X), DisplayLoc(DREG,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_EREG, DisplayLoc(EREG,TOPL_X), DisplayLoc(EREG,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_HREG, DisplayLoc(HREG,TOPL_X), DisplayLoc(HREG,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_LREG, DisplayLoc(LREG,TOPL_X), DisplayLoc(LREG,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_SPREG, DisplayLoc(SPREG,TOPL_X), DisplayLoc(SPREG,TOPL_Y), (2*D_WIDTH) + D_H_SPACE, D_HEIGHT
  GUI AREA A_PCREG, DisplayLoc(PCREG,TOPL_X), DisplayLoc(PCREG,TOPL_Y), (2*D_WIDTH) + D_H_SPACE, D_HEIGHT
  
  GUI AREA A_ALT_FLAGS, DisplayLoc(FLAGS,TOPL_X), DisplayLoc(FLAGS,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_ALT_AREG, DisplayLoc(ALT_AREG,TOPL_X), DisplayLoc(ALT_AREG,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_ALT_BREG, DisplayLoc(ALT_BREG,TOPL_X), DisplayLoc(ALT_BREG,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_ALT_CREG, DisplayLoc(ALT_CREG,TOPL_X), DisplayLoc(ALT_CREg,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_ALT_DREG, DisplayLoc(ALT_DREG,TOPL_X), DisplayLoc(ALT_DREG,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_ALT_EREG, DisplayLoc(ALT_EREG,TOPL_X), DisplayLoc(ALT_EREG,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_ALT_HREG, DisplayLoc(ALT_HREG,TOPL_X), DisplayLoc(ALT_HREG,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_ALT_LREG, DisplayLoc(ALT_LREG,TOPL_X), DisplayLoc(ALT_LREG,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_IX_REG, DisplayLoc(IX_REG,TOPL_X), DisplayLoc(IX_REG,TOPL_Y), (2*D_WIDTH) + D_H_SPACE, D_HEIGHT
  GUI AREA A_IY_REG, DisplayLoc(IY_REG,TOPL_X), DisplayLoc(IY_REG,TOPL_Y), (2*D_WIDTH) + D_H_SPACE, D_HEIGHT
  
  GUI AREA A_ADDRESS_DISPLAY, DisplayLoc(ADDRESS_DISPLAY,TOPL_X), DisplayLoc(ADDRESS_DISPLAY,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_MEMORY_BYTE_DISPLAY, DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_X), DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_Y), D_WIDTH/2, D_HEIGHT
  GUI AREA A_STEP_SIZE, DisplayLoc(STEP_DISPLAY,TOPL_X), DisplayLoc(STEP_DISPLAY,TOPL_Y), D_WIDTH/2, D_HEIGHT
  GUI AREA A_RUN_TO_ADDRESS, DisplayLoc(RUN_TO_DISPLAY,TOPL_X), DisplayLoc(RUN_TO_DISPLAY,TOPL_Y), D_WIDTH, D_HEIGHT
  GUI AREA A_FILE_NAME, MiscLoc_X(0), MiscLoc_Y(0), FILENAME_IN_WIDTH, 20
  ' BUTTON MATRIX
  'first row
  GUI Button C_BUTTON, "C", ButtonMatrix_X(0), ButtonMatrix_Y(0),BUTTON_WIDTH, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  GUI Button D_BUTTON, "D", ButtonMatrix_X(1), ButtonMatrix_Y(1), BUTTON_WIDTH, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  GUI Button E_BUTTON, "E", ButtonMatrix_X(2), ButtonMatrix_Y(2),BUTTON_WIDTH, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  GUI Button F_BUTTON, "F", ButtonMatrix_X(3), ButtonMatrix_Y(3), BUTTON_WIDTH, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  'second row
  GUI Button EIGHT_BUTTON, "8", ButtonMatrix_X(4), ButtonMatrix_Y(4),BUTTON_WIDTH, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  GUI Button NINE_BUTTON, "9", ButtonMatrix_X(5), ButtonMatrix_Y(5), BUTTON_WIDTH, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  GUI Button A_BUTTON, "A", ButtonMatrix_X(6), ButtonMatrix_Y(6),BUTTON_WIDTH, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  GUI Button B_BUTTON, "B", ButtonMatrix_X(7), ButtonMatrix_Y(7), BUTTON_WIDTH, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  'third row
  GUI Button FOUR_BUTTON, "4", ButtonMatrix_X(8), ButtonMatrix_Y(8),BUTTON_WIDTH, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  GUI Button FIVE_BUTTON, "5", ButtonMatrix_X(9), ButtonMatrix_Y(9), BUTTON_WIDTH, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  GUI Button SIX_BUTTON, "6", ButtonMatrix_X(10), ButtonMatrix_Y(10),BUTTON_WIDTH, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  GUI Button SEVEN_BUTTON, "7", ButtonMatrix_X(11), ButtonMatrix_Y(11), BUTTON_WIDTH, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  'fourth row
  GUI Button ZERO_BUTTON, "0", ButtonMatrix_X(12), ButtonMatrix_Y(12),BUTTON_WIDTH, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  GUI Button ONE_BUTTON, "1", ButtonMatrix_X(13), ButtonMatrix_Y(13), BUTTON_WIDTH, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  GUI Button TWO_BUTTON, "2", ButtonMatrix_X(14), ButtonMatrix_Y(14),BUTTON_WIDTH, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  GUI Button THREE_BUTTON, "3", ButtonMatrix_X(15), ButtonMatrix_Y(15), BUTTON_WIDTH, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  'Address Sel
  GUI Button MEM_INC_BUTTON, "INC", ButtonMatrix_X(16), ButtonMatrix_Y(16), BUTTON_WIDTH*2, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
   'Data Sel
  GUI Button MEM_DEC_BUTTON, "DEC", ButtonMatrix_X(17), ButtonMatrix_Y(17), BUTTON_WIDTH*2, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  'OK Button
  GUI Button OK_BUTTON, "OK", ButtonMatrix_X(18), ButtonMatrix_Y(18), BUTTON_WIDTH*2, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  'RST Button
  GUI Button RESET_BUTTON, "RST", ButtonMatrix_X(19), ButtonMatrix_Y(19), BUTTON_WIDTH*2, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  'STEP Button
  GUI Button STEP_BUTTON, "STEP", ButtonMatrix_X(20), ButtonMatrix_Y(20), BUTTON_WIDTH*4, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  'RUN Button
  GUI Button RUN_BUTTON, "RUN", ButtonMatrix_X(21), ButtonMatrix_Y(21), BUTTON_WIDTH*4, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  'EXIT Button
  GUI Button EXIT_BUTTON, "EXIT", ButtonMatrix_X(22), ButtonMatrix_Y(22), BUTTON_WIDTH*4, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  'RUN TO Button
  GUI Button RUN_TO_BUTTON, "RUN TO", ButtonMatrix_X(23), ButtonMatrix_Y(23), BUTTON_WIDTH*4, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  ' Load CP/M Ststem to memory
  GUI Button LOAD_CPM_BUTTON, "LOAD CP/M", ButtonMatrix_X(24), ButtonMatrix_Y(24), BUTTON_WIDTH*4, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  ' Load CP/M file to &H100
  GUI Button LOAD_FILE_BUTTON, "LOAD FILE", ButtonMatrix_X(25), ButtonMatrix_Y(25), BUTTON_WIDTH*4, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  ' Load Hex file
  GUI Button LOAD_HEX_FILE_BUTTON, "LOAD HEX", ButtonMatrix_X(26), ButtonMatrix_Y(26), BUTTON_WIDTH*4, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  ' Zero Memory
  GUI Button ZERO_MEM_BUTTON, "ZERO MEM", ButtonMatrix_X(27), ButtonMatrix_Y(27), BUTTON_WIDTH*4, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  'Log On Button  
  'GUI SWITCH TRACE_ON_BUTTON, "LOG ON|LOG OFF", ButtonMatrix_X(28), ButtonMatrix_Y(28), BUTTON_WIDTH*7, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  GUI Button TRACE_ON_BUTTON, "TRACE", ButtonMatrix_X(28), ButtonMatrix_Y(28), BUTTON_WIDTH*4, D_HEIGHT,RGB(BLACK), RGB(220,220,220)
  GUI LED TRACE_LED, "", ButtonMatrix_X(28)+ BUTTON_WIDTH*5, ButtonMatrix_Y(28)+D_HEIGHT/2, D_HEIGHT/2, RGB(RED)
  GUI FRAME MAIN_FRAME, " Z80 SIMULATOR ", MiscLoc_X(1), MiscLoc_Y(1),  (ButtonMatrix_X(27) + MM.INFO(FONTWIDTH)*3 + (BUTTON_WIDTH*12) + D_H_SPACE) - MiscLoc_X(1), MM.VRES -   MM.INFO(FONTHEIGHT)-MiscLoc_Y(1),D_COLOUR
End Sub

SUB UpdateRegistersDisplay
  ' updates register display on what in register array
  LOCAL AS STRING lsData
  LOCAL as INTEGER lnData
  local as integer lnOpCodeOffset
  LOCAL as INTEGER lnStringIndex
  LOCAL AS INTEGER lnOpCode
  if gnFlagUpdateDisplay = UPDATE_ALL_DISPLAY then
    lsData = HEX$(PEEK(VAR Registers(), FLAG_REG_INDEX),2) + " " + BIN$(PEEK(VAR Registers(), FLAG_REG_INDEX),8)
    TEXT DisplayLoc(FLAGS,TOPL_X) + D_WIDTH/2, DisplayLoc(FLAGS,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    lsData = HEX$(PEEK(VAR Registers(), I_REG_INDEX),2) + " " + BIN$(PEEK(VAR Registers(), I_REG_INDEX),8)
    TEXT DisplayLoc(IREG,TOPL_X) + D_WIDTH/2, DisplayLoc(IREG,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    lsData = HEX$(PEEK(VAR Registers(), A_REG_INDEX),2) + " " + BIN$(PEEK(VAR Registers(), A_REG_INDEX),8)
    TEXT DisplayLoc(AREG,TOPL_X) + D_WIDTH/2, DisplayLoc(AREG,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    ' B&C
   lsData = HEX$(PEEK(VAR Registers(), B_REG_INDEX),2) + " " + BIN$(PEEK(VAR Registers(), B_REG_INDEX),8)
    TEXT DisplayLoc(BREG,TOPL_X) + D_WIDTH/2, DisplayLoc(BREG,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    lsData = HEX$(PEEK(VAR Registers(), C_REG_INDEX),2) + " " + BIN$(PEEK(VAR Registers(), C_REG_INDEX),8)
    TEXT DisplayLoc(CREg,TOPL_X) + D_WIDTH/2, DisplayLoc(CREg,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    'D&E
    lsData = HEX$(PEEK(VAR Registers(), D_REG_INDEX),2) + " " + BIN$(PEEK(VAR Registers(), D_REG_INDEX),8)
    TEXT DisplayLoc(DREG,TOPL_X) + D_WIDTH/2, DisplayLoc(DREG,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    lsData = HEX$(PEEK(VAR Registers(), E_REG_INDEX),2) + " " + BIN$(PEEK(VAR Registers(), E_REG_INDEX),8)
    TEXT DisplayLoc(EREG,TOPL_X) + D_WIDTH/2, DisplayLoc(EREG,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    'H&L
    lsData = HEX$(PEEK(VAR Registers(), H_REG_INDEX),2) + " " + BIN$(PEEK(VAR Registers(), H_REG_INDEX),8)
    TEXT DisplayLoc(HREG,TOPL_X) + D_WIDTH/2, DisplayLoc(HREG,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    lsData = HEX$(PEEK(VAR Registers(), L_REG_INDEX),2) + " " + BIN$(PEEK(VAR Registers(), L_REG_INDEX),8)
    TEXT DisplayLoc(LREG,TOPL_X) + D_WIDTH/2, DisplayLoc(LREG,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    'SP
    lnData = PEEK(VAR Registers(), SPREGHI_INDEX) << 8
    lnData = lnData + PEEK(VAR Registers(), SPREGLO_INDEX)
    lsData = HEX$(lnData,4) + " " + BIN$(lnData,8)
    TEXT DisplayLoc(SPREG,TOPL_X) + D_WIDTH, DisplayLoc(SPREG,TOPL_Y) + D_HEIGHT/2, "                      ", "CMN", 1,1,REG_DATA_COLOUR
    TEXT DisplayLoc(SPREG,TOPL_X) + D_WIDTH, DisplayLoc(SPREG,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    'PC
    DisplayPC
    'IX Reg
    lnData = PEEK(VAR Registers(), IX_REG_MSB_INDEX) << 8
    lnData = lnData + PEEK(VAR Registers(), IX_REG_LSB_INDEX)
    lsData = HEX$(lnData,4) + " " + BIN$(lnData,8)
    TEXT DisplayLoc(IX_REG,TOPL_X) + D_WIDTH, DisplayLoc(IX_REG,TOPL_Y) + D_HEIGHT/2, "                      ", "CMN", 1,1,REG_DATA_COLOUR
    TEXT DisplayLoc(IX_REG,TOPL_X) + D_WIDTH, DisplayLoc(IX_REG,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    'IY Reg
    lnData = PEEK(VAR Registers(), IY_REG_MSB_INDEX) << 8
    lnData = lnData + PEEK(VAR Registers(), IY_REG_LSB_INDEX)
    lsData = HEX$(lnData,4) + " " + BIN$(lnData,8)
    TEXT DisplayLoc(IY_REG,TOPL_X) + D_WIDTH, DisplayLoc(IY_REG,TOPL_Y) + D_HEIGHT/2, "                      ", "CMN", 1,1,REG_DATA_COLOUR
    TEXT DisplayLoc(IY_REG,TOPL_X) + D_WIDTH, DisplayLoc(IY_REG,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    
    'Alt Registers
    lsData = HEX$(PEEK(VAR Registers(), ALT_FLAG_REG_INDEX),2) + " " + BIN$(PEEK(VAR Registers(), ALT_FLAG_REG_INDEX),8)
    TEXT DisplayLoc(ALT_FLAGS,TOPL_X) + D_WIDTH/2, DisplayLoc(ALT_FLAGS,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    lsData = HEX$(PEEK(VAR Registers(), ALT_A_REG_INDEX),2) + " " + BIN$(PEEK(VAR Registers(), ALT_A_REG_INDEX),8)
    TEXT DisplayLoc(ALT_AREG,TOPL_X) + D_WIDTH/2, DisplayLoc(ALT_AREG,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    ' B&C
    'lnData = Registers(2) >> 8
    lsData = HEX$(PEEK(VAR Registers(), ALT_B_REG_INDEX),2) + " " + BIN$(PEEK(VAR Registers(), ALT_B_REG_INDEX),8)
    TEXT DisplayLoc(ALT_BREG,TOPL_X) + D_WIDTH/2, DisplayLoc(ALT_BREG,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    lsData = HEX$(PEEK(VAR Registers(), ALT_C_REG_INDEX),2) + " " + BIN$(PEEK(VAR Registers(), ALT_C_REG_INDEX),8)
    TEXT DisplayLoc(ALT_CREg,TOPL_X) + D_WIDTH/2, DisplayLoc(ALT_CREg,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    'D&E
    lsData = HEX$(PEEK(VAR Registers(), ALT_D_REG_INDEX),2) + " " + BIN$(PEEK(VAR Registers(), ALT_D_REG_INDEX),8)
    TEXT DisplayLoc(ALT_DREG,TOPL_X) + D_WIDTH/2, DisplayLoc(ALT_DREG,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    lsData = HEX$(PEEK(VAR Registers(), ALT_E_REG_INDEX),2) + " " + BIN$(PEEK(VAR Registers(), ALT_E_REG_INDEX),8)
    TEXT DisplayLoc(ALT_EREG,TOPL_X) + D_WIDTH/2, DisplayLoc(ALT_EREG,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    'H&L
    lsData = HEX$(PEEK(VAR Registers(), ALT_H_REG_INDEX),2) + " " + BIN$(PEEK(VAR Registers(), ALT_H_REG_INDEX),8)
    TEXT DisplayLoc(ALT_HREG,TOPL_X) + D_WIDTH/2, DisplayLoc(ALT_HREG,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    lsData = HEX$(PEEK(VAR Registers(), ALT_L_REG_INDEX),2) + " " + BIN$(PEEK(VAR Registers(), ALT_L_REG_INDEX),8)
    TEXT DisplayLoc(ALT_LREG,TOPL_X) + D_WIDTH/2, DisplayLoc(ALT_LREG,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    'SP
    lnData = PEEK(VAR Registers(), SPREGHI_INDEX) << 8
    lnData = lnData + PEEK(VAR Registers(), SPREGLO_INDEX)
    lsData = HEX$(lnData,4) + " " + BIN$(lnData,8)
    TEXT DisplayLoc(SPREG,TOPL_X) + D_WIDTH, DisplayLoc(SPREG,TOPL_Y) + D_HEIGHT/2, "                      ", "CMN", 1,1,REG_DATA_COLOUR
    TEXT DisplayLoc(SPREG,TOPL_X) + D_WIDTH, DisplayLoc(SPREG,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    'address
    TEXT DisplayLoc(ADDRESS_DISPLAY,TOPL_X)+D_WIDTH/2, DisplayLoc(ADDRESS_DISPLAY,TOPL_Y)+ D_HEIGHT/2, HEX$(gnMemoryAddress,4), "CMN", 1,1,REG_DATA_COLOUR
    ' data at address location  
    lsData =HEX$(PEEK(VAR Memory64k(), gnMemoryAddress),2)
    TEXT DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_X)+D_WIDTH/4, DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_Y) + D_HEIGHT/2, lsData, "CMN", 1,1,REG_DATA_COLOUR
    ' Run To Address  
    lnData = PEEK(VAR Registers(), MSB_MMB_RUN_TO_INDEX) << 8
    lnData = lnData + PEEK(VAR Registers(), LSB_MMB_RUN_TO_INDEX)
    TEXT DisplayLoc(RUN_TO_DISPLAY,TOPL_X)+D_WIDTH/4, DisplayLoc(RUN_TO_DISPLAY,TOPL_Y) + D_HEIGHT/2, HEX$(lnData,4), "CMN", 1,1,REG_DATA_COLOUR
    TEXT DisplayLoc(STEP_DISPLAY,TOPL_X)+D_WIDTH/4, DisplayLoc(STEP_DISPLAY,TOPL_Y) + D_HEIGHT/2, HEX$(gnStepDebug,3), "CMN", 1,1,REG_DATA_COLOUR
  else if gnFlagUpdateDisplay = USER_INPUT_MODE then ' just doing user data input
      BOX AND_PIXELS DisplayLoc(USER_DISPLAY,TOPL_X)+D_THICKNESS, DisplayLoc(USER_DISPLAY,TOPL_Y)+D_THICKNESS, D_WIDTH-(2*D_THICKNESS), D_HEIGHT-2*D_THICKNESS, RGB(BLACK)
    if Is16BitDisplay() = 1 then 
      TEXT DisplayLoc(USER_DISPLAY,TOPL_X)+D_WIDTH/4, DisplayLoc(USER_DISPLAY,TOPL_Y) + D_HEIGHT/2, left$(gsUserInput,4), "CMN", 1,1,REG_DATA_COLOUR
    else
      TEXT DisplayLoc(USER_DISPLAY,TOPL_X)+D_WIDTH/4, DisplayLoc(USER_DISPLAY,TOPL_Y) + D_HEIGHT/2, left$(gsUserInput,2), "CMN", 1,1,REG_DATA_COLOUR
    end if
  end if
  UnderlineCTRLChars
  gnFlagUpdateDisplay = 0 ' only do once
END SUB

SUB SetDisplayInput
' checks if display selectd for input
  local as FLOAT lfTemp
  'set selected to not selected
  select case gnCurrentInputDisplay
    case FLAGS
      TEXT DisplayLoc(FLAGS,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)), DisplayLoc(FLAGS,TOPL_Y) + L_Y_OFFSET, "F", "LMN", 1,1,L_COLOUR
    case IREG
      TEXT DisplayLoc(IREG,TOPL_X)+ D_WIDTH + L_X_OFFSET), DisplayLoc(IREG,TOPL_Y) + L_Y_OFFSET, "I", "LMN", 1,1,L_COLOUR
    case AREG
      TEXT DisplayLoc(AREG,TOPL_X)- L_X_OFFSET - MM.INFO(FONTWIDTH), DisplayLoc(AREG,TOPL_Y) + L_Y_OFFSET, "A", "LMN", 1,1,L_COLOUR
    case BREG
      TEXT DisplayLoc(BREG,TOPL_X)- L_X_OFFSET - MM.INFO(FONTWIDTH), DisplayLoc(BREG,TOPL_Y) + L_Y_OFFSET, "B", "LMN", 1,1,L_COLOUR
    case CREg
      TEXT DisplayLoc(CREg,TOPL_X)+ D_WIDTH + L_X_OFFSET, DisplayLoc(CREg,TOPL_Y) + L_Y_OFFSET, "C", "LMN", 1,1,L_COLOUR
    case DREG
      TEXT DisplayLoc(DREG,TOPL_X)- L_X_OFFSET - MM.INFO(FONTWIDTH), DisplayLoc(DREG,TOPL_Y) + L_Y_OFFSET, "D", "LMN", 1,1,L_COLOUR
    case EREG
      TEXT DisplayLoc(EREG,TOPL_X)+ D_WIDTH+ L_X_OFFSET, DisplayLoc(EREG,TOPL_Y) + L_Y_OFFSET, "E", "LMN", 1,1,L_COLOUR
    case HREG
      TEXT DisplayLoc(HREG,TOPL_X)- L_X_OFFSET - MM.INFO(FONTWIDTH), DisplayLoc(HREG,TOPL_Y) + L_Y_OFFSET, "H", "LMN", 1,1,L_COLOUR
    case LREG
      TEXT DisplayLoc(LREG,TOPL_X)+ D_WIDTH+ L_X_OFFSET, DisplayLoc(LREG,TOPL_Y) + L_Y_OFFSET, "L", "LMN", 1,1,L_COLOUR
    case ADDRESS_DISPLAY
      TEXT DisplayLoc(ADDRESS_DISPLAY,TOPL_X)+D_WIDTH/2, DisplayLoc(ADDRESS_DISPLAY,TOPL_Y) - L_Y_OFFSET/1.5, "ADDRESS", "CMN", 1,1,L_COLOUR
    CASE MEMORY_BYTE_DISPLAY
      TEXT DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_X)+D_WIDTH/4, DisplayLoc(MEMORY_BYTE_DISPLAY,TOPL_Y) - L_Y_OFFSET/1.5, "MEMORY", "CMN", 1,1,L_COLOUR
    CASE RUN_TO_DISPLAY
      TEXT DisplayLoc(RUN_TO_DISPLAY,TOPL_X)+D_WIDTH/2, DisplayLoc(RUN_TO_DISPLAY,TOPL_Y) - L_Y_OFFSET/1.5, "STOP ADDRESS", "CMN", 1,1,L_COLOUR  
    CASE STEP_DISPLAY
      TEXT DisplayLoc(STEP_DISPLAY,TOPL_X)+D_WIDTH/4, DisplayLoc(STEP_DISPLAY,TOPL_Y) - L_Y_OFFSET/1.5, "STEP", "CMN", 1,1,L_COLOUR 
    case IX_REG
      TEXT DisplayLoc(IX_REG,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)*2), DisplayLoc(IX_REG,TOPL_Y) + L_Y_OFFSET, "IX", "LMN", 1,1,L_COLOUR
    case IY_REG
      TEXT DisplayLoc(IY_REG,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)*2), DisplayLoc(IY_REG,TOPL_Y) + L_Y_OFFSET, "IY", "LMN", 1,1,L_COLOUR 
    case IREG
      TEXT DisplayLoc(IREG,TOPL_X)+ D_WIDTH + L_X_OFFSET), DisplayLoc(IREG,TOPL_Y) + L_Y_OFFSET, "I", "LMN", 1,1,L_COLOUR  
    end select
   select case gnLastButtonPressed
    case A_FLAGS
      gnCurrentInputDisplay = FLAGS
            TEXT DisplayLoc(gnCurrentInputDisplay,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)), DisplayLoc(gnCurrentInputDisplay,TOPL_Y) + L_Y_OFFSET, "F", "LMN", 1,1,RGB(GREEN)
    case A_IREG
      gnCurrentInputDisplay = IREG
            TEXT DisplayLoc(gnCurrentInputDisplay,TOPL_X)+ D_WIDTH + L_X_OFFSET), DisplayLoc(gnCurrentInputDisplay,TOPL_Y) + L_Y_OFFSET, "I", "LMN", 1,1,RGB(GREEN)
    case A_AREG
      gnCurrentInputDisplay = AREG
            TEXT DisplayLoc(gnCurrentInputDisplay,TOPL_X)- L_X_OFFSET - MM.INFO(FONTWIDTH), DisplayLoc(gnCurrentInputDisplay,TOPL_Y) + L_Y_OFFSET, "A", "LMN", 1,1,RGB(GREEN)
    case A_BREG
      gnCurrentInputDisplay = BREG
            TEXT DisplayLoc(gnCurrentInputDisplay,TOPL_X)- L_X_OFFSET - MM.INFO(FONTWIDTH), DisplayLoc(gnCurrentInputDisplay,TOPL_Y) + L_Y_OFFSET, "B", "LMN", 1,1,RGB(GREEN)
    case A_CREg
      gnCurrentInputDisplay = CREg
      TEXT DisplayLoc(gnCurrentInputDisplay,TOPL_X)+ D_WIDTH + L_X_OFFSET, DisplayLoc(gnCurrentInputDisplay,TOPL_Y) + L_Y_OFFSET, "C", "LMN", 1,1,RGB(GREEN)
    case A_DREG
      gnCurrentInputDisplay = DREG
      TEXT DisplayLoc(gnCurrentInputDisplay,TOPL_X)- L_X_OFFSET - MM.INFO(FONTWIDTH), DisplayLoc(gnCurrentInputDisplay,TOPL_Y) + L_Y_OFFSET, "D", "LMN", 1,1,RGB(GREEN)
    case A_EREG
      gnCurrentInputDisplay = EREG
      TEXT DisplayLoc(gnCurrentInputDisplay,TOPL_X)+ D_WIDTH+ L_X_OFFSET, DisplayLoc(gnCurrentInputDisplay,TOPL_Y) + L_Y_OFFSET, "E", "LMN", 1,1,RGB(GREEN)
    case A_HREG
      gnCurrentInputDisplay = HREG
      TEXT DisplayLoc(gnCurrentInputDisplay,TOPL_X)- L_X_OFFSET - MM.INFO(FONTWIDTH), DisplayLoc(gnCurrentInputDisplay,TOPL_Y) + L_Y_OFFSET, "H", "LMN", 1,1,RGB(GREEN)
    case A_LREG
      gnCurrentInputDisplay = LREG
      TEXT DisplayLoc(gnCurrentInputDisplay,TOPL_X)+ D_WIDTH+ L_X_OFFSET, DisplayLoc(gnCurrentInputDisplay,TOPL_Y) + L_Y_OFFSET, "L", "LMN", 1,1,RGB(GREEN)
    case A_ADDRESS_DISPLAY
      gnCurrentInputDisplay = ADDRESS_DISPLAY
      TEXT DisplayLoc(gnCurrentInputDisplay,TOPL_X)+D_WIDTH/2, DisplayLoc(gnCurrentInputDisplay,TOPL_Y) - L_Y_OFFSET/1.5, "ADDRESS", "CMN", 1,1,RGB(GREEN) 
'PRINT " Current Display = ", gnCurrentInputDisplay, "  X = ", DisplayLoc(ADDRESS_DISPLAY,TOPL_X)+D_WIDTH/2,"  Y = ", DisplayLoc(gnCurrentInputDisplay,TOPL_Y) - L_Y_OFFSET/1.5 
    CASE A_MEMORY_BYTE_DISPLAY
      gnCurrentInputDisplay = MEMORY_BYTE_DISPLAY
      TEXT DisplayLoc(gnCurrentInputDisplay,TOPL_X)+D_WIDTH/4,  DisplayLoc(gnCurrentInputDisplay,TOPL_Y) - L_Y_OFFSET/1.5, "MEMORY", "CMN", 1,1, RGB(GREEN) 
    CASE A_RUN_TO_ADDRESS
      gnCurrentInputDisplay = RUN_TO_DISPLAY
      TEXT DisplayLoc(gnCurrentInputDisplay,TOPL_X)+D_WIDTH/2,DisplayLoc(gnCurrentInputDisplay,TOPL_Y) - L_Y_OFFSET/1.5, "STOP ADDRESS", "CMN", 1,1,RGB(GREEN)
    CASE A_STEP_SIZE
      gnCurrentInputDisplay = STEP_DISPLAY
      TEXT DisplayLoc(gnCurrentInputDisplay,TOPL_X)+D_WIDTH/4, DisplayLoc(gnCurrentInputDisplay,TOPL_Y) - L_Y_OFFSET/1.5, "STEP", "CMN", 1,1,RGB(GREEN)   
    case A_IX_REG
      gnCurrentInputDisplay = IX_REG
      TEXT DisplayLoc(IX_REG,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)*2), DisplayLoc(IX_REG,TOPL_Y) + L_Y_OFFSET, "IX", "LMN", 1,1,RGB(GREEN)
    case A_IY_REG
      gnCurrentInputDisplay = IY_REG
      TEXT DisplayLoc(IY_REG,TOPL_X)- L_X_OFFSET - (MM.INFO(FONTWIDTH)*2), DisplayLoc(IY_REG,TOPL_Y) + L_Y_OFFSET, "IY", "LMN", 1,1,RGB(GREEN)  
    case A_IREG
      gnCurrentInputDisplay = IREG
      TEXT DisplayLoc(IREG,TOPL_X)+ D_WIDTH + L_X_OFFSET), DisplayLoc(IREG,TOPL_Y) + L_Y_OFFSET, "I", "LMN", 1,1,L_COLOUR           
   end select
end SUB

SUB DisplayPC
' Displays Program Counter and its assembly code
  TEXT DisplayLoc(PCREG,TOPL_X) + D_WIDTH, DisplayLoc(PCREG,TOPL_Y) + D_HEIGHT/2, "                        ", "CMN", 1,1,REG_DATA_COLOUR ' erase 24 chars
  TEXT DisplayLoc(PCREG,TOPL_X) + D_WIDTH, DisplayLoc(PCREG,TOPL_Y) + D_HEIGHT/2, GetInstString(), "CMN", 1,1,REG_DATA_COLOUR
End Sub 

FUNCTION GetInstString () AS STRING 
  LOCAL as Integer lnOpCode, lnPCReg, lnCurrentPC, nStringIndex, lnOpCodeOffset, nStartCode
  LOCAL AS STRING lsData
  lnPCReg = PEEK(VAR Registers(), PCREGHI_INDEX) << 8
  lnPCReg = lnPCReg + PEEK(VAR Registers(), PCREGLO_INDEX)
  lnCurrentPC = lnPCReg
  nStartCode = PEEK(VAR Memory64k(), lnPCReg)
  SELECT CASE nStartCode
    CASE 0 TO &HCA, &HCC to &HDC, &HDE TO &HEC, &HEE TO &HFC,&HFE TO &HFF
      nStringIndex = FIX(nStartCode / 20)    
      lnOpCodeOffset = nStartCode MOD 20 
      lsData = HEX$(lnCurrentPC,4) + ":" + HEX$(nStartCode,2) + " [" + MID$(gsMainIn(nStringIndex), (lnOpCodeOffset *10) +1, 10 )+"]" ' 10 chars per opcode
    case &HCB
      INC lnPCReg
      lnOpCode = PEEK(VAR Memory64k(), lnPCReg)
      lsData = GetBIT_OpCode(lnOpCode, lnCurrentPC)
    CASE &HCC TO &HDC
      nStringIndex = FIX(nStartCode / 20)    
      lnOpCodeOffset = nStartCode MOD 20 
      lsData = HEX$(lnCurrentPC,4) + ":" + HEX$(nStartCode,2) + " [" + MID$(gsMainIn(nStringIndex), (lnOpCodeOffset *10) +1, 10 )+ "]" ' 10 chars per opcode 
    CASE &HDD
      INC lnPCReg
      lnOpCode = PEEK(VAR Memory64k(), lnPCReg)
      lsData = GetDD_OpCode(lnOpCode, lnCurrentPC)
    case &HED
      INC lnPCReg
      lnOpCode = PEEK(VAR Memory64k(), lnPCReg)
      lsData = GetEXT_OpCode(lnOpCode, lnCurrentPC)
    CASE &HFD
      INC lnPCReg
      lnOpCode = PEEK(VAR Memory64k(), lnPCReg)
      lsData = GetFD_OpCode(lnOpCode, lnCurrentPC) 
    end select 
    GetInstString = lsData
end function

FUNCTION GetBIT_OpCode ( nCode as INTEGER, PCReg as INTEGER) AS STRING
' Enters with Code set to the Byte after CB
  LOCAL INTEGER nStringIndex, lnOpCodeOffset
  LOCAL STRING sReg, sBit
  SELECT CASE nCode
    CASE 0 TO &H3F '
      nStringIndex = FIX(nCODE / 20)    
      lnOpCodeOffset = nCODE MOD 20 
      GetBIT_OpCode = HEX$(PCReg,4) + ":CB" + HEX$(nCode,2) + " [" + MID$(gsBITSIn(nStringIndex), (lnOpCodeOffset *10) +1, 10 ) + "]" ' 10 chars per opcode
    CASE &H40 TO &H7F
      sBit = STR$( ((nCode >> 3) AND 7) ) 
      GetBIT_OpCode = HEX$(PCReg,4) + ":CB" + HEX$(nCode,2) + " [" + "BIT " + STR$( ((nCode >> 3) AND 7) ) + "," +  ExtractReg(nCode) + "]"
    CASE &H80 TO &HBF
      sBit = STR$( ((nCode >> 3) AND 7) ) 
      GetBIT_OpCode = HEX$(PCReg,4) + ":CB" + HEX$(nCode,2) + " [ " + "RES " + STR$( ((nCode >> 3) AND 7) ) + "," +  ExtractReg(nCode) + "]"
    CASE &HC0 TO &HFF
      sBit = STR$( ((nCode >> 3) AND 7) ) 
      GetBIT_OpCode = HEX$(PCReg,4) + ":CB" + HEX$(nCode,2) + " [ " + "SET " + STR$( ((nCode >> 3) AND 7) ) + "," +  ExtractReg(nCode) + "]"
  END SELECT
END FUNCTION

FUNCTION GetEXT_OpCode ( nCode as INTEGER, PCReg as INTEGER) AS STRING
' Enters with Code set to the Byte after ED
  LOCAL INTEGER lnStringIndex, lnOpCodeOffset, nCorrCode
  LOCAL STRING sReg, sBit
  nCorrCode = nCode - &H40
  SELECT CASE nCode
    CASE &H40 TO &H7F '
      lnStringIndex = FIX(nCorrCode / 20)    
      lnOpCodeOffset = nCorrCode MOD 20 
      GetEXT_OpCode = HEX$(PCReg,4) + ":ED" + HEX$(nCode,2) + " [" + MID$(gsEXT_In(lnStringIndex), (lnOpCodeOffset *10) +1, 10 ) + "]" ' 10 chars per opcode
	CASE &HA0 TO &HB3
		lnStringIndex = 4
		lnOpCodeOffset = nCode - &HA0
		GetEXT_OpCode = HEX$(PCReg,4) + ":ED" + HEX$(nCode,2) + " [" + MID$(gsEXT_In(lnStringIndex), (lnOpCodeOffset *10) +1, 10 ) + "]" ' 10 chars per opcode
    CASE &HB4 TO &HBB
      lnStringIndex = 5    
      lnOpCodeOffset = nCode - &HB4
      GetEXT_OpCode = HEX$(PCReg,4) + ":ED" + HEX$(nCode,2) + " [" + MID$(gsEXT_In(lnStringIndex), (lnOpCodeOffset *10) +1, 10 ) + "]" ' 10 chars per opcode
  END SELECT
END FUNCTION

FUNCTION GetDD_OpCode ( nCode as INTEGER, PCReg as INTEGER) AS STRING
' Enters with Code set to the Byte after DD (can also be DDCBnnXX)
  LOCAL INTEGER lnStringIndex, lnOpCodeOffset, lnPCReg, lnOpCode
  LOCAL AS STRING sCodeString
  SELECT CASE nCode
  CASE &H0 TO &H3F 
      lnStringIndex = FIX(nCode / 16) 
	  lnOpCodeOffset = nCode MOD 16 
      sCodeString = MID$(gsIX__In(lnStringIndex), (lnOpCodeOffset *12) +1, 12 ) ' 12 chars per opcode
    CASE &H46  
      sCodeString = "LD B,(IX+d)"
    CASE &H4E  
      sCodeString = "LD C,(IX+d)"  
    CASE &H56  
      sCodeString = "LD D,(IX+d)"
    CASE &H5E  
      sCodeString = "LD E,(IX+d)"  
    CASE &H66  
      sCodeString = "LD H,(IX+d)"
    CASE &H6E  
      sCodeString = "LD L,(IX+d)"  
    CASE &H70 to &H7F  
		lnOpCodeOffset = nCode MOD 16 
      sCodeString = MID$(gsIX__In(4), (lnOpCodeOffset *12) +1, 12 ) ' 12 chars per opcode        
    CASE &H86  
      sCodeString = "ADD A,(IX+d)"
    CASE &H8E  
      sCodeString = "ADC A,(IX+d)"   
    CASE &H96  
      sCodeString = "SUB(IX+d)"
    CASE &H9E  
      sCodeString = "SBC A,(IX+d)"  
    CASE &HA6  
      sCodeString = "AND(IX+d)"
    CASE &HAE  
      sCodeString = "XOR(IX+d)"    
    CASE &HB6  
      sCodeString = "OR(IX+d)"
    CASE &HBE  
      sCodeString = "CP(IX+d)"   
    CASE &HCB
      lnPCReg = PCReg ' at DD
	  lnPCReg = PCReg + 3	' at 4th byte of instruction
	  lnOpCode = PEEK(VAR Memory64k(), lnPCReg)
      sCodeString = GetDDCB_OpCode(lnOpCode, lnPCReg)
    CASE &HE0 to &HEF  
		lnOpCodeOffset = nCode MOD 16 
      sCodeString = MID$(gsIX__In(5), (lnOpCodeOffset *12) +1, 12 ) ' 12 chars per opcode        
    CASE &HF9  
      sCodeString = "LD SP,IX"                  
  END SELECT
  GetDD_OpCode = HEX$(PCReg,4) + ":DD" + HEX$(nCode,2) + " [" + sCodeString + "]"
END FUNCTION 

FUNCTION GetDDCB_OpCode ( nCode as INTEGER, PCReg as INTEGER) AS STRING
' Enters with Code set to the Byte after DDCBnn, all instruction codes are 4 byte
  LOCAL INTEGER nBit
  LOCAL AS STRING sCodeString
  SELECT CASE nCode
    CASE &H06  
      sCodeString = "RLC(IX+d)"
    CASE &H0E  
      sCodeString = "RRC(IX+d)"  
    CASE &H16  
      sCodeString = "RL(IX+d)"
    CASE &H1E  
      sCodeString = "RR(IX+d)"   
    CASE &H26  
      sCodeString = "SLA(IX+d)"
    CASE &H2E  
      sCodeString = "SRA(IX+d)"  
    CASE &H3E  
      sCodeString = "SRL(IX+d)" 
    CASE &H46 TO &H7E
      nBit = (nCode >> 3) AND 7
      sCodeString = "BIT" + STR$(nBit) + ",(IX+d)" 
    CASE &H80 TO &HBE
	   nBit = (nCode >> 3) AND 7
      sCodeString = "RES" + STR$(nBit) + ",(IX+d)"   
    CASE &HC0 TO &HFE
	  nBit = (nCode >> 3) AND 7
      sCodeString = "SET" + STR$(nBit) + ",(IX+d)"     
  END SELECT
  GetDDCB_OpCode = sCodeString
END FUNCTION 

FUNCTION GetFD_OpCode ( nCode as INTEGER, PCReg as INTEGER) AS STRING
' Enters with Code set to the Byte after DD
  LOCAL INTEGER lnStringIndex, lnOpCodeOffset, lnPCReg, lnOpCode
  LOCAL AS STRING sCodeString
  SELECT CASE nCode
  CASE &H0 TO &H3F 
      lnStringIndex = FIX(nCode / 16)    
      lnOpCodeOffset = nCode MOD 16 
      sCodeString = MID$(gsIY__In(lnStringIndex), (lnOpCodeOffset *12) +1, 12 ) ' 12 chars per opcode
    CASE &H46  
      sCodeString = "LD B,(IY+d)"
    CASE &H4E  
      sCodeString = "LD C,(IY+d)"  
    CASE &H56  
      sCodeString = "LD D,(IY+d)"
    CASE &H5E  
      sCodeString = "LD E,(IY+d)"  
    CASE &H66  
      sCodeString = "LD H,(IY+d)"
    CASE &H6E  
      sCodeString = "LD L,(IY+d)"  
    CASE &H70 to &H7F  
		lnOpCodeOffset = nCode MOD 16 
      sCodeString = MID$(gsIY__In(4), (lnOpCodeOffset *12) +1, 12 ) ' 12 chars per opcode        
    CASE &H86  
      sCodeString = "ADD A,(IY+d)"
    CASE &H8E  
      sCodeString = "ADC A,(IY+d)"   
    CASE &H96  
      sCodeString = "SUB(IY+d)"
    CASE &H9E  
      sCodeString = "SBC A,(IY+d)"  
    CASE &HA6  
      sCodeString = "AND(IY+d)"
    CASE &HAE  
      sCodeString = "XOR(IY+d)"    
    CASE &HB6  
      sCodeString = "OR(IY+d)"
    CASE &HBE  
      sCodeString = "CP(IY+d)"   
    CASE &HCB
      lnPCReg = PCReg ' at FD
	  lnPCReg = PCReg + 3	' at 4th byte of instruction
      lnOpCode = PEEK(VAR Memory64k(), lnPCReg)
      sCodeString = GetFDCB_OpCode(lnOpCode, lnPCReg)
    CASE &HE0 to &HEF  
		lnOpCodeOffset = nCode MOD 16 
      sCodeString = MID$(gsIY__In(5), (lnOpCodeOffset *12) +1, 12 ) ' 12 chars per opcode        
    CASE &HF9  
      sCodeString = "LD SP,IY"                  
  END SELECT
  GetFD_OpCode = HEX$(PCReg,4) + ":FD" + HEX$(nCode,2) + " [" + sCodeString + "]"
END FUNCTION 

FUNCTION GetFDCB_OpCode ( nCode as INTEGER, PCReg as INTEGER) AS STRING
' Enters with Code set to the Byte after DDCB
  LOCAL INTEGER nBit
  LOCAL AS STRING sCodeString
  SELECT CASE nCode
    CASE &H06  
      sCodeString = "RLC(IY+d)"
    CASE &H0E  
      sCodeString = "RRC(IY+d)"  
    CASE &H16  
      sCodeString = "RL(IY+d)"
    CASE &H1E  
      sCodeString = "RR(IY+d)"   
    CASE &H26  
      sCodeString = "SLA(IY+d)"
    CASE &H2E  
      sCodeString = "SRA(IY+d)"  
    CASE &H3E  
      sCodeString = "SRL(IY+d)" 
    CASE &H46 TO &H7E
      nBit = (nCode >> 3) AND 7
      sCodeString = "BIT" + STR$(nBit) + ",(IY+d)" 
    CASE &H80 TO &HBE
      nBit = (nCode >> 3) AND 7
      sCodeString = "RES" + STR$(nBit) + ",(IY+d)"   
    CASE &HC0 TO &HFE
      nBit = (nCode >> 3) AND 7
      sCodeString = "SET" + STR$(nBit) + ",(IY+d)"     
  END SELECT
  GetFDCB_OpCode = sCodeString
END FUNCTION 


FUNCTION ExtractReg(nCode AS INTEGER) AS STRING
' extracts reg from nCode, Reg is as per Z*) manual and bits 0 to 3
  SELECT CASE (nCode AND 7)
        case 0
          ExtractReg = "B"
        case 1
          ExtractReg = "C"
        case 2
          ExtractReg = "D" 
        case 3
          ExtractReg = "E"  
        case 4
          ExtractReg = "H" 
        case 5
          ExtractReg = "L"   
        case 6
          ExtractReg = "(HL)" 
        case 7
          ExtractReg = "A"    
      END SELECT
END FUNCTION

sub UnderLineButtonChar nChar AS INTEGER, nTitleLen AS INTEGER, nIndex as INTEGER, ButtonSize AS INTEGER
  LOCAL INTEGER NXTemp=0
  if nTitleLen AND 1 then 'odd
    NXTemp = MM.INFO(FONTWIDTH) / 2
  endif
  NXTemp = (ButtonMatrix_X(nIndex) + (ButtonSize /2)) - (NXTemp + ((nTitleLen >> 1) * MM.INFO(FONTWIDTH))) 'start of first char
  NXTemp = NXTemp + (MM.INFO(FONTWIDTH)*(nChar-1))
  LINE NXTemp +2, ButtonMatrix_Y(nIndex) + UNDERLINE_YOFFSET, NXTemp + MM.INFO(FONTWIDTH)-2, ButtonMatrix_Y(nIndex) + UNDERLINE_YOFFSET,1, RGB(BLACK)
end sub

SUB UnderlineCTRLChars
  'INC Button=I
  UnderLineButtonChar 1, 3, 16,MEDIUM_BUTTON_WIDTH 
   'Data DEC =D
   UnderLineButtonChar 1, 3, 17, MEDIUM_BUTTON_WIDTH
  'OK Button
  UnderLineButtonChar 1, 2, 18,MEDIUM_BUTTON_WIDTH 
  'RST Button =T
  UnderLineButtonChar 3, 3, 19, MEDIUM_BUTTON_WIDTH 
  'STEP Button = S
  UnderLineButtonChar 1, 4, 20, LARGE_BUTTON_WIDTH
  'RUN Button = R
  UnderLineButtonChar 1, 3, 21, LARGE_BUTTON_WIDTH
  'EXIT Button = X
  UnderLineButtonChar 2, 4, 22, LARGE_BUTTON_WIDTH
  'RUN TO Button =U
  UnderLineButtonChar 2, 6, 23, LARGE_BUTTON_WIDTH
  ' Load CP/M to memory = M 
  UnderLineButtonChar 9, 9, 24, LARGE_BUTTON_WIDTH
  ' Load CP/M file to &H100 = F
  UnderLineButtonChar 6, 9, 25, LARGE_BUTTON_WIDTH
  ' Load Hex file = H
  UnderLineButtonChar 6, 8, 26, LARGE_BUTTON_WIDTH
  ' Zero Memory = Z
  UnderLineButtonChar 1, 8, 27, LARGE_BUTTON_WIDTH
  'TRACE On Button = A 
  UnderLineButtonChar 3, 5, 28, LARGE_BUTTON_WIDTH
end sub

SUB DrawCharHat nX as INTEGER, nY as INTEGER, nChar as Integer, nTextLen as INTEGER, nHJust as INTEGER
  'Left justification nHJust = 1, Centre is 2, Right not addressed 
  ' assumes Middle justification
 LOCAL INTEGER nTemp =0
 if nHJust = 1 then
  nTemp = nX + (nChar-1) * MM.INFO(FONTWIDTH)
 else ' centre
    if nTextLen AND 1 then
      nTemp = MM.INFO(FONTWIDTH)/2
    endif
    nTemp = nX - (nTemp + ((nTextLen >> 1) * MM.INFO(FONTWIDTH)))
    nTemp = nTemp + (MM.INFO(FONTWIDTH) * (nChar-1))
 endif
 LINE nTemp+2, nY- HATLINE_YOFFSET, nTemp + MM.INFO(FONTWIDTH)-2, nY- HATLINE_YOFFSET ,1, RGB(YELLOW) 
End sub

Function InputFileName(npX AS INTEGER, npY AS INTEGER) AS STRING
LOCAL STRING sKeyIn, sFileName 
LOCAL INTEGER nTemp, nChar, nTimer,nX,nY
nX = npX+4
nY = npY + MM.INFO(FONTHEIGHT) + 2
nChar = 1
LINE nX, nY+2, nX + (MM.INFO(FONTWIDTH)*nChar), nY+2 ,1, RGB(GREEN)'prompt
DO
  sKeyIn =INKEY$
  IF sKeyIn <> "" THEN
    nTemp = ASC(sKeyIn)
    Select Case nTemp
    case 8,127 ' backspace
      nChar = CHOICE(nChar > 1,nChar-1,1) 
      IF LEN(sFileName) > 0 then
        sFileName = LEFT$(sFileName,LEN(sFileName)-1) 
      Endif
    case 65 to 90,48 to 57,97 to 122, 46,95 'alpha, number,'.', '_'
      sFileName = sFileName + sKeyIn
      INC nChar
     case 10,13
      InputFileName = sFileName
      LINE nX+ (MM.INFO(FONTWIDTH)*(nChar-1)), nY+2, nX + (MM.INFO(FONTWIDTH)*nChar), nY+2 ,1, RGB(BLACK) 'turn off prompt
      TEXT nX, nY+2, "                 ","LBN",1,1,RGB(WHITE)
      TEXT nX, nY+2, sFileName,"LBN",1,1,RGB(RED)
      Exit Do ' have name
   END SELECT
   LINE nX, nY+2, nX + FILENAME_IN_WIDTH-6, nY+2 ,1, RGB(BLACK) 'erase
   TEXT nX, nY+2, "                 ","LBN",1,1,RGB(WHITE)
   TEXT nX, nY+2, sFileName,"LBN",1,1,RGB(WHITE)
 ENDIF ' if key press
 IF nChar < 18 Then 'max 17 chars in file name only accepted
    nTimer = Timer/100
    if nTimer AND 5 THEN 'blink
      LINE nX+ (MM.INFO(FONTWIDTH)*(nChar-1)), nY+2, nX + (MM.INFO(FONTWIDTH)*nChar), nY+2 ,1, RGB(GREEN)
    else
      LINE nX+ (MM.INFO(FONTWIDTH)*(nChar-1)), nY+2, nX + (MM.INFO(FONTWIDTH)*nChar), nY+2 ,1, RGB(BLACK)
    endif
  Endif
LOOP
End Function

SUB WarnUserMsg sTitle as String, sMsg AS STRING
BOX 200, 200, MSG_BOX_WIDTH, MSG_BOX_HEIGHT,3 , RGB(RED),RGB(220,220,220)
TEXT 200 + MSG_BOX_WIDTH/2, 200 + MM.INFO(FONTHEIGHT)*4, "ERROR", "CBN", 1,1.5,RGB(RED),RGB(220,220,220)
TEXT 200 + MSG_BOX_WIDTH/2, 200 + MM.INFO(FONTHEIGHT) * 6, sTitle, "CBN", 1,1,RGB(RED),RGB(220,220,220)
TEXT 200 + MSG_BOX_WIDTH/2, 200 + MM.INFO(FONTHEIGHT) * 8, sMsg, "CBN", 1,1,RGB(RED),RGB(220,220,220)
TEXT 200 + MSG_BOX_WIDTH/2, 200 + MM.INFO(FONTHEIGHT) * 12, "PRESS ANY KET TO CONT..", "CBN", 1,1,RGB(RED),RGB(220,220,220)
Do While INKEY$ = ""
LOOP
END SUB


#INCLUDE "Z80Sim_CSUB.INC"
